/* predicate.c generated by valac 0.52.10, the Vala compiler
 * generated from predicate.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <glib-object.h>
#include <glib.h>
#include <string.h>

/**
     * Matches a seahorse object and a predicate
     *
     * @param obj The predicate to match
     *
     * @return false if predicate does not match the Object, true else
     */
gboolean
seahorse_predicate_match (SeahorsePredicate *self,
                          GObject* obj)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp7_ = FALSE;
	SeahorsePredicateFunc _tmp8_;
	gboolean result = FALSE;
#line 41 "../common/predicate.vala"
	g_return_val_if_fail (obj != NULL, FALSE);
#line 43 "../common/predicate.vala"
	if ((*self).type != ((GType) 0)) {
#line 52 "predicate.c"
		gboolean _tmp1_ = FALSE;
#line 43 "../common/predicate.vala"
		if (g_type_is_a (G_TYPE_FROM_INSTANCE (obj), (*self).type)) {
#line 43 "../common/predicate.vala"
			_tmp1_ = g_type_is_a ((*self).type, G_TYPE_FROM_INSTANCE (obj));
#line 58 "predicate.c"
		} else {
#line 43 "../common/predicate.vala"
			_tmp1_ = FALSE;
#line 62 "predicate.c"
		}
#line 43 "../common/predicate.vala"
		_tmp0_ = !_tmp1_;
#line 66 "predicate.c"
	} else {
#line 43 "../common/predicate.vala"
		_tmp0_ = FALSE;
#line 70 "predicate.c"
	}
#line 43 "../common/predicate.vala"
	if (_tmp0_) {
#line 44 "../common/predicate.vala"
		result = FALSE;
#line 44 "../common/predicate.vala"
		return result;
#line 78 "predicate.c"
	}
#line 46 "../common/predicate.vala"
	if ((*self).usage != SEAHORSE_USAGE_NONE) {
#line 82 "predicate.c"
		SeahorseUsage obj_usage = 0;
		SeahorseUsage _tmp2_ = 0;
#line 47 "../common/predicate.vala"
		obj_usage = SEAHORSE_USAGE_NONE;
#line 48 "../common/predicate.vala"
		g_object_get (obj, "usage", &_tmp2_, NULL, NULL);
#line 48 "../common/predicate.vala"
		obj_usage = _tmp2_;
#line 50 "../common/predicate.vala"
		if ((*self).usage != obj_usage) {
#line 51 "../common/predicate.vala"
			result = FALSE;
#line 51 "../common/predicate.vala"
			return result;
#line 97 "predicate.c"
		}
	}
#line 54 "../common/predicate.vala"
	if ((*self).flags != 0) {
#line 54 "../common/predicate.vala"
		_tmp3_ = TRUE;
#line 104 "predicate.c"
	} else {
#line 54 "../common/predicate.vala"
		_tmp3_ = (*self).nflags != 0;
#line 108 "predicate.c"
	}
#line 54 "../common/predicate.vala"
	if (_tmp3_) {
#line 112 "predicate.c"
		SeahorseFlags obj_flags = 0U;
		SeahorseFlags _tmp4_ = 0U;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 55 "../common/predicate.vala"
		obj_flags = SEAHORSE_FLAG_NONE;
#line 56 "../common/predicate.vala"
		g_object_get (obj, "object-flags", &_tmp4_, NULL, NULL);
#line 56 "../common/predicate.vala"
		obj_flags = _tmp4_;
#line 58 "../common/predicate.vala"
		if ((*self).flags != SEAHORSE_FLAG_NONE) {
#line 58 "../common/predicate.vala"
			_tmp5_ = ((*self).flags & obj_flags) == obj_flags;
#line 127 "predicate.c"
		} else {
#line 58 "../common/predicate.vala"
			_tmp5_ = FALSE;
#line 131 "predicate.c"
		}
#line 58 "../common/predicate.vala"
		if (_tmp5_) {
#line 59 "../common/predicate.vala"
			result = FALSE;
#line 59 "../common/predicate.vala"
			return result;
#line 139 "predicate.c"
		}
#line 60 "../common/predicate.vala"
		if ((*self).nflags != SEAHORSE_FLAG_NONE) {
#line 60 "../common/predicate.vala"
			_tmp6_ = !(((*self).nflags & obj_flags) == obj_flags);
#line 145 "predicate.c"
		} else {
#line 60 "../common/predicate.vala"
			_tmp6_ = FALSE;
#line 149 "predicate.c"
		}
#line 60 "../common/predicate.vala"
		if (_tmp6_) {
#line 61 "../common/predicate.vala"
			result = FALSE;
#line 61 "../common/predicate.vala"
			return result;
#line 157 "predicate.c"
		}
	}
#line 65 "../common/predicate.vala"
	_tmp8_ = (*self).custom;
#line 65 "../common/predicate.vala"
	if (_tmp8_ != NULL) {
#line 164 "predicate.c"
		SeahorsePredicateFunc _tmp9_;
		void* _tmp10_;
#line 65 "../common/predicate.vala"
		_tmp9_ = (*self).custom;
#line 65 "../common/predicate.vala"
		_tmp10_ = (*self).custom_target;
#line 65 "../common/predicate.vala"
		_tmp7_ = !_tmp9_ (obj, _tmp10_);
#line 173 "predicate.c"
	} else {
#line 65 "../common/predicate.vala"
		_tmp7_ = FALSE;
#line 177 "predicate.c"
	}
#line 65 "../common/predicate.vala"
	if (_tmp7_) {
#line 66 "../common/predicate.vala"
		result = FALSE;
#line 66 "../common/predicate.vala"
		return result;
#line 185 "predicate.c"
	}
#line 68 "../common/predicate.vala"
	result = TRUE;
#line 68 "../common/predicate.vala"
	return result;
#line 191 "predicate.c"
}

SeahorsePredicate*
seahorse_predicate_dup (const SeahorsePredicate* self)
{
	SeahorsePredicate* dup;
#line 26 "../common/predicate.vala"
	dup = g_new0 (SeahorsePredicate, 1);
#line 26 "../common/predicate.vala"
	memcpy (dup, self, sizeof (SeahorsePredicate));
#line 26 "../common/predicate.vala"
	return dup;
#line 204 "predicate.c"
}

void
seahorse_predicate_free (SeahorsePredicate* self)
{
#line 26 "../common/predicate.vala"
	g_free (self);
#line 212 "predicate.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_predicate_get_type_once (void)
{
	GType seahorse_predicate_type_id;
	seahorse_predicate_type_id = g_boxed_type_register_static ("SeahorsePredicate", (GBoxedCopyFunc) seahorse_predicate_dup, (GBoxedFreeFunc) seahorse_predicate_free);
	return seahorse_predicate_type_id;
}

GType
seahorse_predicate_get_type (void)
{
	static volatile gsize seahorse_predicate_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_predicate_type_id__volatile)) {
		GType seahorse_predicate_type_id;
		seahorse_predicate_type_id = seahorse_predicate_get_type_once ();
		g_once_init_leave (&seahorse_predicate_type_id__volatile, seahorse_predicate_type_id);
	}
	return seahorse_predicate_type_id__volatile;
}

