/* util.c generated by valac 0.52.10, the Vala compiler
 * generated from util.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004-2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../common/util.vala"
	return self ? g_object_ref (self) : NULL;
#line 41 "util.c"
}

void
seahorse_util_show_error (GtkWidget* parent,
                          const gchar* heading,
                          const gchar* message)
{
	GtkWindow* window = NULL;
	GtkMessageDialog* dialog = NULL;
	GtkWindow* _tmp2_;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp6_;
	GtkMessageDialog* _tmp7_;
#line 26 "../common/util.vala"
	window = NULL;
#line 28 "../common/util.vala"
	if (message == NULL) {
#line 29 "../common/util.vala"
		message = "";
#line 61 "util.c"
	}
#line 31 "../common/util.vala"
	if (parent != NULL) {
#line 32 "../common/util.vala"
		if (!G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
#line 67 "util.c"
			GtkWidget* _tmp0_;
#line 33 "../common/util.vala"
			_tmp0_ = gtk_widget_get_toplevel (parent);
#line 33 "../common/util.vala"
			parent = _tmp0_;
#line 73 "util.c"
		}
#line 34 "../common/util.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ())) {
#line 77 "util.c"
			GtkWindow* _tmp1_;
#line 35 "../common/util.vala"
			_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (parent, gtk_window_get_type (), GtkWindow));
#line 35 "../common/util.vala"
			_g_object_unref0 (window);
#line 35 "../common/util.vala"
			window = _tmp1_;
#line 85 "util.c"
		}
	}
#line 38 "../common/util.vala"
	_tmp2_ = window;
#line 38 "../common/util.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new (_tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "");
#line 38 "../common/util.vala"
	g_object_ref_sink (_tmp3_);
#line 38 "../common/util.vala"
	dialog = _tmp3_;
#line 41 "../common/util.vala"
	if (heading == NULL) {
#line 98 "util.c"
		GtkMessageDialog* _tmp4_;
#line 42 "../common/util.vala"
		_tmp4_ = dialog;
#line 42 "../common/util.vala"
		g_object_set ((GObject*) _tmp4_, "text", message, NULL);
#line 104 "util.c"
	} else {
		GtkMessageDialog* _tmp5_;
#line 44 "../common/util.vala"
		_tmp5_ = dialog;
#line 44 "../common/util.vala"
		g_object_set ((GObject*) _tmp5_, "text", heading, "secondary-text", message, NULL);
#line 111 "util.c"
	}
#line 46 "../common/util.vala"
	_tmp6_ = dialog;
#line 46 "../common/util.vala"
	gtk_dialog_run ((GtkDialog*) _tmp6_);
#line 47 "../common/util.vala"
	_tmp7_ = dialog;
#line 47 "../common/util.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp7_);
#line 23 "../common/util.vala"
	_g_object_unref0 (dialog);
#line 23 "../common/util.vala"
	_g_object_unref0 (window);
#line 125 "util.c"
}

gchar*
seahorse_util_get_display_date_string (guint64 time)
{
	GDateTime* created_date = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 52 "../common/util.vala"
	if (time == ((guint64) 0)) {
#line 138 "util.c"
		gchar* _tmp0_;
#line 53 "../common/util.vala"
		_tmp0_ = g_strdup ("");
#line 53 "../common/util.vala"
		result = _tmp0_;
#line 53 "../common/util.vala"
		return result;
#line 146 "util.c"
	}
#line 54 "../common/util.vala"
	_tmp1_ = g_date_time_new_from_unix_utc ((gint64) time);
#line 54 "../common/util.vala"
	created_date = _tmp1_;
#line 55 "../common/util.vala"
	_tmp2_ = created_date;
#line 55 "../common/util.vala"
	_tmp3_ = g_date_time_format (_tmp2_, "%x");
#line 55 "../common/util.vala"
	result = _tmp3_;
#line 55 "../common/util.vala"
	_g_date_time_unref0 (created_date);
#line 55 "../common/util.vala"
	return result;
#line 162 "util.c"
}

gboolean
seahorse_util_list_store_find (GListStore* store,
                               GObject* item,
                               guint* position)
{
	guint _vala_position = 0U;
	GEqualFunc _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean result = FALSE;
#line 59 "../common/util.vala"
	g_return_val_if_fail (store != NULL, FALSE);
#line 59 "../common/util.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 60 "../common/util.vala"
	_tmp0_ = g_direct_equal;
#line 60 "../common/util.vala"
	_tmp2_ = seahorse_util_list_store_find_with_equal_func (store, item, _tmp0_, &_tmp1_);
#line 60 "../common/util.vala"
	_vala_position = _tmp1_;
#line 60 "../common/util.vala"
	result = _tmp2_;
#line 60 "../common/util.vala"
	if (position) {
#line 60 "../common/util.vala"
		*position = _vala_position;
#line 191 "util.c"
	}
#line 60 "../common/util.vala"
	return result;
#line 195 "util.c"
}

gboolean
seahorse_util_list_store_find_with_equal_func (GListStore* store,
                                               GObject* item,
                                               GEqualFunc func,
                                               guint* position)
{
	guint _vala_position = 0U;
	gboolean result = FALSE;
#line 64 "../common/util.vala"
	g_return_val_if_fail (store != NULL, FALSE);
#line 64 "../common/util.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 210 "util.c"
	{
		guint i = 0U;
#line 68 "../common/util.vala"
		i = (guint) 0;
#line 215 "util.c"
		{
			gboolean _tmp0_ = FALSE;
#line 68 "../common/util.vala"
			_tmp0_ = TRUE;
#line 68 "../common/util.vala"
			while (TRUE) {
#line 222 "util.c"
				GObject* _tmp2_;
				GObject* _tmp3_;
				gboolean _tmp4_;
#line 68 "../common/util.vala"
				if (!_tmp0_) {
#line 228 "util.c"
					guint _tmp1_;
#line 68 "../common/util.vala"
					_tmp1_ = i;
#line 68 "../common/util.vala"
					i = _tmp1_ + 1;
#line 234 "util.c"
				}
#line 68 "../common/util.vala"
				_tmp0_ = FALSE;
#line 68 "../common/util.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) store))) {
#line 68 "../common/util.vala"
					break;
#line 242 "util.c"
				}
#line 69 "../common/util.vala"
				_tmp2_ = g_list_model_get_item ((GListModel*) store, i);
#line 69 "../common/util.vala"
				_tmp3_ = _tmp2_;
#line 69 "../common/util.vala"
				_tmp4_ = func (_tmp3_, item);
#line 69 "../common/util.vala"
				_g_object_unref0 (_tmp3_);
#line 69 "../common/util.vala"
				if (_tmp4_) {
#line 70 "../common/util.vala"
					if ((&_vala_position) != NULL) {
#line 71 "../common/util.vala"
						_vala_position = i;
#line 258 "util.c"
					}
#line 72 "../common/util.vala"
					result = TRUE;
#line 72 "../common/util.vala"
					if (position) {
#line 72 "../common/util.vala"
						*position = _vala_position;
#line 266 "util.c"
					}
#line 72 "../common/util.vala"
					return result;
#line 270 "util.c"
				}
			}
		}
	}
#line 76 "../common/util.vala"
	result = FALSE;
#line 76 "../common/util.vala"
	if (position) {
#line 76 "../common/util.vala"
		*position = _vala_position;
#line 281 "util.c"
	}
#line 76 "../common/util.vala"
	return result;
#line 285 "util.c"
}

