/* source.c generated by valac 0.52.10, the Vala compiler
 * generated from source.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004-2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (c) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gstdio.h>
#include "seahorse-common.h"
#include <gcr/gcr-base.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

enum  {
	SEAHORSE_SSH_SOURCE_0_PROPERTY,
	SEAHORSE_SSH_SOURCE_LABEL_PROPERTY,
	SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY,
	SEAHORSE_SSH_SOURCE_URI_PROPERTY,
	SEAHORSE_SSH_SOURCE_ICON_PROPERTY,
	SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY,
	SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY,
	SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY,
	SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY,
	SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY,
	SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY,
	SEAHORSE_SSH_SOURCE_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SeahorseSshSourceAddKeyFromFilenameData SeahorseSshSourceAddKeyFromFilenameData;
typedef struct _Block10Data Block10Data;
typedef struct _SeahorseSshSourceLoadKeyForPrivateFileData SeahorseSshSourceLoadKeyForPrivateFileData;
typedef struct _Block11Data Block11Data;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
typedef struct _SeahorseSshSourceLoadData SeahorseSshSourceLoadData;
typedef struct _Block12Data Block12Data;
typedef struct _SeahorseSshSourceImportAsyncData SeahorseSshSourceImportAsyncData;
typedef struct _SeahorseSshSourceImportPublicAsyncData SeahorseSshSourceImportPublicAsyncData;
typedef struct _Block13Data Block13Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _SeahorseSshSourceAuthorizeAsyncData SeahorseSshSourceAuthorizeAsyncData;

struct _SeahorseSshSourcePrivate {
	gchar* ssh_homedir;
	guint scheduled_refresh_source;
	GFileMonitor* monitor_handle;
	GListStore* keys;
};

struct _SeahorseSshSourceAddKeyFromFilenameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	gchar* privfile;
	SeahorseSshKey* result;
	guint i;
	gboolean _tmp0_;
	guint _tmp1_;
	GListStore* _tmp2_;
	SeahorseSshKey* key;
	GListStore* _tmp3_;
	GObject* _tmp4_;
	SeahorseSshKey* _tmp5_;
	SeahorseSshKeyData* _tmp6_;
	SeahorseSshKeyData* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	SeahorseSshKey* _tmp10_;
	SeahorseSshKey* _tmp11_;
	SeahorseSshKey* _tmp12_;
	GError* _inner_error0_;
};

struct _Block10Data {
	int _ref_count_;
	SeahorseSshSource* self;
	gchar* pubfile;
	SeahorseSshKey* key;
	gchar* privfile;
	gpointer _async_data_;
};

struct _SeahorseSshSourceLoadKeyForPrivateFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	gchar* privfile;
	SeahorseSshKey* result;
	Block10Data* _data10_;
	gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* e;
	const gchar* _tmp5_;
	GError* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	SeahorseSshKey* _tmp12_;
	SeahorseSshKey* _tmp13_;
	GError* _inner_error0_;
};

struct _Block11Data {
	int _ref_count_;
	SeahorseSshSource* self;
	gchar* pubfile;
	gpointer _async_data_;
};

struct _SeahorseSshSourceLoadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	GCancellable* cancellable;
	gboolean result;
	Block11Data* _data11_;
	GDir* dir;
	const gchar* _tmp0_;
	GDir* _tmp1_;
	gchar* filename;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* privfile;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_;
};

struct _Block12Data {
	int _ref_count_;
	SeahorseSshSource* self;
	gchar* fullpath;
	SeahorseSshSource* src;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _SeahorseSshSourceImportAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	GInputStream* input;
	GtkWindow* transient_for;
	GCancellable* cancellable;
	GList* result;
	Block12Data* _data12_;
	guint8* buffer;
	guint8* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gsize bytes_read;
	gsize _tmp1_;
	gchar* _tmp2_;
	SeahorseSshSource* _tmp3_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceImportPublicAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	SeahorseSshKeyData* data;
	gchar* filename;
	GCancellable* cancellable;
	gchar* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _Block13Data {
	int _ref_count_;
	SeahorseSshSource* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	GError* err;
	gchar* from;
	gchar* to;
	SeahorseSshKey* key;
	gpointer _async_data_;
};

struct _SeahorseSshSourceAuthorizeAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	SeahorseSshKey* key;
	gboolean authorize;
	Block13Data* _data13_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GThread* thread;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError* _inner_error0_;
};

static gint SeahorseSshSource_private_offset;
static gpointer seahorse_ssh_source_parent_class = NULL;
static GcrCollectionIface * seahorse_ssh_source_gcr_collection_parent_iface = NULL;
static SeahorsePlaceIface * seahorse_ssh_source_seahorse_place_parent_iface = NULL;

static gboolean seahorse_ssh_source_check_file_for_ssh (SeahorseSshSource* self,
                                                 const gchar* filename);
static void seahorse_ssh_source_cancel_scheduled_refresh (SeahorseSshSource* self);
static gboolean seahorse_ssh_source_scheduled_refresh (SeahorseSshSource* self);
static gboolean seahorse_ssh_source_scheduled_dummy (SeahorseSshSource* self);
static void seahorse_ssh_source_monitor_ssh_homedir (SeahorseSshSource* self);
static void ___lambda19_ (SeahorseSshSource* self,
                   GFile* file,
                   GFile* other_file,
                   GFileMonitorEvent event_type);
static gboolean _seahorse_ssh_source_scheduled_refresh_gsource_func (gpointer self);
static void ____lambda19__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static guint seahorse_ssh_source_real_get_length (GcrCollection* base);
static GList* seahorse_ssh_source_real_get_objects (GcrCollection* base);
static gboolean seahorse_ssh_source_real_contains (GcrCollection* base,
                                            GObject* object);
static void seahorse_ssh_source_add_key_from_filename_data_free (gpointer _data);
static gboolean seahorse_ssh_source_add_key_from_filename_co (SeahorseSshSourceAddKeyFromFilenameData* _data_);
static void seahorse_ssh_source_load_key_for_private_file (SeahorseSshSource* self,
                                                    const gchar* privfile,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static SeahorseSshKey* seahorse_ssh_source_load_key_for_private_file_finish (SeahorseSshSource* self,
                                                                      GAsyncResult* _res_,
                                                                      GError** error);
static void seahorse_ssh_source_add_key_from_filename_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void seahorse_ssh_source_load_key_for_private_file_data_free (gpointer _data);
static gboolean seahorse_ssh_source_load_key_for_private_file_co (SeahorseSshSourceLoadKeyForPrivateFileData* _data_);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static gboolean ____lambda16_ (Block10Data* _data10_,
                        SeahorseSshKeyData* keydata);
static gboolean _____lambda16__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                             gpointer self);
static void seahorse_ssh_source_load_key_for_private_file_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void seahorse_ssh_source_real_load_data_free (gpointer _data);
static void seahorse_ssh_source_real_load (SeahorsePlace* base,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean seahorse_ssh_source_real_load_co (SeahorseSshSourceLoadData* _data_);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean _seahorse_ssh_source_scheduled_dummy_gsource_func (gpointer self);
static gboolean __lambda17_ (Block11Data* _data11_,
                      SeahorseSshKeyData* keydata);
static gboolean ___lambda17__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                           gpointer self);
static gboolean __lambda18_ (Block11Data* _data11_,
                      SeahorseSshKeyData* keydata);
static gboolean ___lambda18__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                           gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void seahorse_ssh_source_import_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_import_async_co (SeahorseSshSourceImportAsyncData* _data_);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static gboolean __lambda20_ (Block12Data* _data12_,
                      SeahorseSshKeyData* keydata);
static gboolean ___lambda20__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                           gpointer self);
static gboolean __lambda21_ (Block12Data* _data12_,
                      SeahorseSshSecData* secdata);
static gboolean ___lambda21__seahorse_ssh_key_priv_parsed_handler (SeahorseSshSecData* data,
                                                            gpointer self);
static void seahorse_ssh_source_import_public_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_import_public_async_co (SeahorseSshSourceImportPublicAsyncData* _data_);
static void seahorse_ssh_source_authorize_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_authorize_async_co (SeahorseSshSourceAuthorizeAsyncData* _data_);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static gboolean _seahorse_ssh_source_authorize_async_co_gsource_func (gpointer self);
static void* __lambda11_ (Block13Data* _data13_);
static void seahorse_ssh_source_ensure_file_exists (SeahorseSshSource* self,
                                             const gchar* filename);
static gpointer ___lambda11__gthread_func (gpointer self);
static GObject * seahorse_ssh_source_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void seahorse_ssh_source_finalize (GObject * obj);
static GType seahorse_ssh_source_get_type_once (void);
static void _vala_seahorse_ssh_source_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_seahorse_ssh_source_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
seahorse_ssh_source_get_instance_private (SeahorseSshSource* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshSource_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 391 "source.c"
}

static gboolean
seahorse_ssh_source_check_file_for_ssh (SeahorseSshSource* self,
                                        const gchar* filename)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 103 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../ssh/source.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 104 "../ssh/source.vala"
	if (!g_file_test (filename, G_FILE_TEST_IS_REGULAR)) {
#line 105 "../ssh/source.vala"
		result = FALSE;
#line 105 "../ssh/source.vala"
		return result;
#line 410 "source.c"
	}
	{
		gchar* contents = NULL;
		gchar* _tmp0_ = NULL;
		const gchar* _tmp2_;
#line 109 "../ssh/source.vala"
		g_file_get_contents (filename, &_tmp0_, NULL, &_inner_error0_);
#line 109 "../ssh/source.vala"
		_g_free0 (contents);
#line 109 "../ssh/source.vala"
		contents = _tmp0_;
#line 109 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "source.c"
			gboolean _tmp1_ = FALSE;
#line 109 "../ssh/source.vala"
			_g_free0 (contents);
#line 109 "../ssh/source.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 430 "source.c"
				goto __catch0_g_file_error;
			}
#line 109 "../ssh/source.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../ssh/source.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../ssh/source.vala"
			return _tmp1_;
#line 439 "source.c"
		}
#line 112 "../ssh/source.vala"
		_tmp2_ = contents;
#line 112 "../ssh/source.vala"
		result = string_contains (_tmp2_, " PRIVATE KEY-----");
#line 112 "../ssh/source.vala"
		_g_free0 (contents);
#line 112 "../ssh/source.vala"
		return result;
#line 449 "source.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 107 "../ssh/source.vala"
		e = _inner_error0_;
#line 107 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 114 "../ssh/source.vala"
		_tmp3_ = e;
#line 114 "../ssh/source.vala"
		_tmp4_ = _tmp3_->message;
#line 114 "../ssh/source.vala"
		_tmp5_ = g_strdup_printf ("Error reading file '%s' to check for SSH key. %s", filename, _tmp4_);
#line 114 "../ssh/source.vala"
		_tmp6_ = _tmp5_;
#line 114 "../ssh/source.vala"
		g_warning ("source.vala:114: %s", _tmp6_);
#line 114 "../ssh/source.vala"
		_g_free0 (_tmp6_);
#line 107 "../ssh/source.vala"
		_g_error_free0 (e);
#line 477 "source.c"
	}
	__finally0:
#line 107 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 482 "source.c"
		gboolean _tmp7_ = FALSE;
#line 107 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 107 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 107 "../ssh/source.vala"
		return _tmp7_;
#line 490 "source.c"
	}
#line 117 "../ssh/source.vala"
	result = FALSE;
#line 117 "../ssh/source.vala"
	return result;
#line 496 "source.c"
}

static void
seahorse_ssh_source_cancel_scheduled_refresh (SeahorseSshSource* self)
{
#line 120 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 121 "../ssh/source.vala"
	if (self->priv->scheduled_refresh_source != ((guint) 0)) {
#line 122 "../ssh/source.vala"
		g_debug ("source.vala:122: Cancelling scheduled refresh event");
#line 123 "../ssh/source.vala"
		g_source_remove (self->priv->scheduled_refresh_source);
#line 124 "../ssh/source.vala"
		self->priv->scheduled_refresh_source = (guint) 0;
#line 512 "source.c"
	}
}

static gboolean
seahorse_ssh_source_scheduled_refresh (SeahorseSshSource* self)
{
	gboolean result = FALSE;
#line 128 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 129 "../ssh/source.vala"
	g_debug ("source.vala:129: Scheduled refresh event ocurring now");
#line 130 "../ssh/source.vala"
	seahorse_ssh_source_cancel_scheduled_refresh (self);
#line 131 "../ssh/source.vala"
	seahorse_place_load ((SeahorsePlace*) self, NULL, NULL, NULL);
#line 132 "../ssh/source.vala"
	result = FALSE;
#line 132 "../ssh/source.vala"
	return result;
#line 532 "source.c"
}

static gboolean
seahorse_ssh_source_scheduled_dummy (SeahorseSshSource* self)
{
	gboolean result = FALSE;
#line 135 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../ssh/source.vala"
	g_debug ("source.vala:136: Dummy refresh event occurring now");
#line 137 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = (guint) 0;
#line 138 "../ssh/source.vala"
	result = FALSE;
#line 138 "../ssh/source.vala"
	return result;
#line 549 "source.c"
}

static gboolean
_seahorse_ssh_source_scheduled_refresh_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_scheduled_refresh ((SeahorseSshSource*) self);
#line 169 "../ssh/source.vala"
	return result;
#line 559 "source.c"
}

static void
___lambda19_ (SeahorseSshSource* self,
              GFile* file,
              GFile* other_file,
              GFileMonitorEvent event_type)
{
	gboolean _tmp0_ = FALSE;
	gchar* path = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
#line 148 "../ssh/source.vala"
	g_return_if_fail (file != NULL);
#line 149 "../ssh/source.vala"
	if (self->priv->scheduled_refresh_source != ((guint) 0)) {
#line 149 "../ssh/source.vala"
		_tmp0_ = TRUE;
#line 582 "source.c"
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 150 "../ssh/source.vala"
		if (event_type != G_FILE_MONITOR_EVENT_CHANGED) {
#line 151 "../ssh/source.vala"
			_tmp3_ = event_type != G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT;
#line 591 "source.c"
		} else {
#line 150 "../ssh/source.vala"
			_tmp3_ = FALSE;
#line 595 "source.c"
		}
#line 150 "../ssh/source.vala"
		if (_tmp3_) {
#line 152 "../ssh/source.vala"
			_tmp2_ = event_type != G_FILE_MONITOR_EVENT_DELETED;
#line 601 "source.c"
		} else {
#line 150 "../ssh/source.vala"
			_tmp2_ = FALSE;
#line 605 "source.c"
		}
#line 150 "../ssh/source.vala"
		if (_tmp2_) {
#line 153 "../ssh/source.vala"
			_tmp1_ = event_type != G_FILE_MONITOR_EVENT_CREATED;
#line 611 "source.c"
		} else {
#line 150 "../ssh/source.vala"
			_tmp1_ = FALSE;
#line 615 "source.c"
		}
#line 150 "../ssh/source.vala"
		_tmp0_ = _tmp1_;
#line 619 "source.c"
	}
#line 149 "../ssh/source.vala"
	if (_tmp0_) {
#line 154 "../ssh/source.vala"
		return;
#line 625 "source.c"
	}
#line 156 "../ssh/source.vala"
	_tmp4_ = g_file_get_path (file);
#line 156 "../ssh/source.vala"
	path = _tmp4_;
#line 157 "../ssh/source.vala"
	_tmp5_ = path;
#line 157 "../ssh/source.vala"
	if (_tmp5_ == NULL) {
#line 158 "../ssh/source.vala"
		_g_free0 (path);
#line 158 "../ssh/source.vala"
		return;
#line 639 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (event_type != G_FILE_MONITOR_EVENT_DELETED) {
#line 643 "source.c"
		const gchar* _tmp10_;
#line 162 "../ssh/source.vala"
		_tmp10_ = path;
#line 162 "../ssh/source.vala"
		_tmp9_ = !g_str_has_suffix (_tmp10_, SEAHORSE_SSH_SOURCE_AUTHORIZED_KEYS_FILE);
#line 649 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp9_ = FALSE;
#line 653 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp9_) {
#line 657 "source.c"
		const gchar* _tmp11_;
#line 163 "../ssh/source.vala"
		_tmp11_ = path;
#line 163 "../ssh/source.vala"
		_tmp8_ = !g_str_has_suffix (_tmp11_, SEAHORSE_SSH_SOURCE_OTHER_KEYS_FILE);
#line 663 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp8_ = FALSE;
#line 667 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp8_) {
#line 671 "source.c"
		const gchar* _tmp12_;
#line 164 "../ssh/source.vala"
		_tmp12_ = path;
#line 164 "../ssh/source.vala"
		_tmp7_ = !g_str_has_suffix (_tmp12_, ".pub");
#line 677 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp7_ = FALSE;
#line 681 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp7_) {
#line 685 "source.c"
		const gchar* _tmp13_;
#line 165 "../ssh/source.vala"
		_tmp13_ = path;
#line 165 "../ssh/source.vala"
		_tmp6_ = !seahorse_ssh_sec_data_contains_private_key (_tmp13_);
#line 691 "source.c"
	} else {
#line 161 "../ssh/source.vala"
		_tmp6_ = FALSE;
#line 695 "source.c"
	}
#line 161 "../ssh/source.vala"
	if (_tmp6_) {
#line 166 "../ssh/source.vala"
		_g_free0 (path);
#line 166 "../ssh/source.vala"
		return;
#line 703 "source.c"
	}
#line 168 "../ssh/source.vala"
	g_debug ("source.vala:168: Scheduling refresh event due to file changes");
#line 169 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _seahorse_ssh_source_scheduled_refresh_gsource_func, g_object_ref (self), g_object_unref);
#line 148 "../ssh/source.vala"
	_g_free0 (path);
#line 711 "source.c"
}

static void
____lambda19__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 148 "../ssh/source.vala"
	___lambda19_ ((SeahorseSshSource*) self, file, other_file, event_type);
#line 723 "source.c"
}

static void
seahorse_ssh_source_monitor_ssh_homedir (SeahorseSshSource* self)
{
	GFile* dot_ssh_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 141 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 142 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 142 "../ssh/source.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 142 "../ssh/source.vala"
	dot_ssh_dir = _tmp1_;
#line 143 "../ssh/source.vala"
	_tmp2_ = dot_ssh_dir;
#line 143 "../ssh/source.vala"
	if (_tmp2_ == NULL) {
#line 144 "../ssh/source.vala"
		_g_object_unref0 (dot_ssh_dir);
#line 144 "../ssh/source.vala"
		return;
#line 750 "source.c"
	}
	{
		GFileMonitor* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileMonitor* _tmp5_;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
#line 147 "../ssh/source.vala"
		_tmp4_ = dot_ssh_dir;
#line 147 "../ssh/source.vala"
		_tmp5_ = g_file_monitor_directory (_tmp4_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 147 "../ssh/source.vala"
		_tmp3_ = _tmp5_;
#line 147 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 766 "source.c"
			goto __catch0_g_error;
		}
#line 147 "../ssh/source.vala"
		_tmp6_ = _tmp3_;
#line 147 "../ssh/source.vala"
		_tmp3_ = NULL;
#line 147 "../ssh/source.vala"
		_g_object_unref0 (self->priv->monitor_handle);
#line 147 "../ssh/source.vala"
		self->priv->monitor_handle = _tmp6_;
#line 148 "../ssh/source.vala"
		_tmp7_ = self->priv->monitor_handle;
#line 148 "../ssh/source.vala"
		g_signal_connect_object (_tmp7_, "changed", (GCallback) ____lambda19__g_file_monitor_changed, self, 0);
#line 146 "../ssh/source.vala"
		_g_object_unref0 (_tmp3_);
#line 783 "source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 146 "../ssh/source.vala"
		e = _inner_error0_;
#line 146 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 172 "../ssh/source.vala"
		_tmp8_ = self->priv->ssh_homedir;
#line 172 "../ssh/source.vala"
		_tmp9_ = e;
#line 172 "../ssh/source.vala"
		_tmp10_ = _tmp9_->message;
#line 172 "../ssh/source.vala"
		g_warning ("source.vala:172: couldn't monitor ssh directory: %s: %s", _tmp8_, _tmp10_);
#line 146 "../ssh/source.vala"
		_g_error_free0 (e);
#line 806 "source.c"
	}
	__finally0:
#line 146 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../ssh/source.vala"
		_g_object_unref0 (dot_ssh_dir);
#line 146 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 146 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 146 "../ssh/source.vala"
		return;
#line 819 "source.c"
	}
#line 141 "../ssh/source.vala"
	_g_object_unref0 (dot_ssh_dir);
#line 823 "source.c"
}

static guint
seahorse_ssh_source_real_get_length (GcrCollection* base)
{
	SeahorseSshSource * self;
	GListStore* _tmp0_;
	guint result = 0U;
#line 176 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 177 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 177 "../ssh/source.vala"
	result = g_list_model_get_n_items ((GListModel*) _tmp0_);
#line 177 "../ssh/source.vala"
	return result;
#line 840 "source.c"
}

static GList*
seahorse_ssh_source_real_get_objects (GcrCollection* base)
{
	SeahorseSshSource * self;
	GList* objects = NULL;
	GList* result = NULL;
#line 180 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 181 "../ssh/source.vala"
	objects = NULL;
#line 853 "source.c"
	{
		guint i = 0U;
#line 182 "../ssh/source.vala"
		i = (guint) 0;
#line 858 "source.c"
		{
			gboolean _tmp0_ = FALSE;
#line 182 "../ssh/source.vala"
			_tmp0_ = TRUE;
#line 182 "../ssh/source.vala"
			while (TRUE) {
#line 865 "source.c"
				GListStore* _tmp2_;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				GObject* _tmp5_;
#line 182 "../ssh/source.vala"
				if (!_tmp0_) {
#line 872 "source.c"
					guint _tmp1_;
#line 182 "../ssh/source.vala"
					_tmp1_ = i;
#line 182 "../ssh/source.vala"
					i = _tmp1_ + 1;
#line 878 "source.c"
				}
#line 182 "../ssh/source.vala"
				_tmp0_ = FALSE;
#line 182 "../ssh/source.vala"
				_tmp2_ = self->priv->keys;
#line 182 "../ssh/source.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp2_))) {
#line 182 "../ssh/source.vala"
					break;
#line 888 "source.c"
				}
#line 183 "../ssh/source.vala"
				_tmp3_ = self->priv->keys;
#line 183 "../ssh/source.vala"
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, i);
#line 183 "../ssh/source.vala"
				_tmp5_ = _tmp4_;
#line 183 "../ssh/source.vala"
				objects = g_list_append (objects, _tmp5_);
#line 183 "../ssh/source.vala"
				_g_object_unref0 (_tmp5_);
#line 900 "source.c"
			}
		}
	}
#line 184 "../ssh/source.vala"
	result = objects;
#line 184 "../ssh/source.vala"
	return result;
#line 908 "source.c"
}

static gboolean
seahorse_ssh_source_real_contains (GcrCollection* base,
                                   GObject* object)
{
	SeahorseSshSource * self;
	GListStore* _tmp0_;
	gboolean result = FALSE;
#line 187 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 187 "../ssh/source.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 188 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 188 "../ssh/source.vala"
	result = seahorse_util_list_store_find (_tmp0_, object, NULL);
#line 188 "../ssh/source.vala"
	return result;
#line 928 "source.c"
}

void
seahorse_ssh_source_remove_object (SeahorseSshSource* self,
                                   GObject* object)
{
	guint pos = 0U;
	GListStore* _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
#line 191 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 191 "../ssh/source.vala"
	g_return_if_fail (object != NULL);
#line 193 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 193 "../ssh/source.vala"
	_tmp2_ = seahorse_util_list_store_find (_tmp0_, object, &_tmp1_);
#line 193 "../ssh/source.vala"
	pos = _tmp1_;
#line 193 "../ssh/source.vala"
	if (_tmp2_) {
#line 951 "source.c"
		GListStore* _tmp3_;
#line 194 "../ssh/source.vala"
		_tmp3_ = self->priv->keys;
#line 194 "../ssh/source.vala"
		g_list_store_remove (_tmp3_, pos);
#line 195 "../ssh/source.vala"
		g_signal_emit_by_name ((GcrCollection*) self, "removed", object);
#line 959 "source.c"
	}
}

gchar*
seahorse_ssh_source_authorized_keys_path (SeahorseSshSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 199 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 200 "../ssh/source.vala"
	_tmp1_ = g_build_filename (_tmp0_, SEAHORSE_SSH_SOURCE_AUTHORIZED_KEYS_FILE, NULL);
#line 200 "../ssh/source.vala"
	result = _tmp1_;
#line 200 "../ssh/source.vala"
	return result;
#line 979 "source.c"
}

gchar*
seahorse_ssh_source_other_keys_path (SeahorseSshSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 203 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 204 "../ssh/source.vala"
	_tmp1_ = g_build_filename (_tmp0_, SEAHORSE_SSH_SOURCE_OTHER_KEYS_FILE, NULL);
#line 204 "../ssh/source.vala"
	result = _tmp1_;
#line 204 "../ssh/source.vala"
	return result;
#line 998 "source.c"
}

static void
seahorse_ssh_source_add_key_from_filename_data_free (gpointer _data)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceAddKeyFromFilenameData, _data_);
#line 1014 "source.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../ssh/source.vala"
	return self ? g_object_ref (self) : NULL;
#line 1022 "source.c"
}

void
seahorse_ssh_source_add_key_from_filename (SeahorseSshSource* self,
                                           const gchar* privfile,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
	SeahorseSshSource* _tmp0_;
	gchar* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceAddKeyFromFilenameData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_add_key_from_filename_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = g_strdup (privfile);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_data_->privfile = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_add_key_from_filename_co (_data_);
#line 1054 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_add_key_from_filename_finish (SeahorseSshSource* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	SeahorseSshKey* result;
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 1070 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 1078 "source.c"
}

static void
seahorse_ssh_source_add_key_from_filename_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
#line 219 "../ssh/source.vala"
	_data_ = _user_data_;
#line 219 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 219 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 219 "../ssh/source.vala"
	seahorse_ssh_source_add_key_from_filename_co (_data_);
#line 1095 "source.c"
}

static gboolean
seahorse_ssh_source_add_key_from_filename_co (SeahorseSshSourceAddKeyFromFilenameData* _data_)
{
#line 207 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 207 "../ssh/source.vala"
		case 0:
#line 1105 "source.c"
		goto _state_0;
#line 207 "../ssh/source.vala"
		case 1:
#line 1109 "source.c"
		goto _state_1;
		default:
#line 207 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1114 "source.c"
	}
	_state_0:
#line 208 "../ssh/source.vala"
	if (_data_->privfile == NULL) {
#line 209 "../ssh/source.vala"
		_data_->result = NULL;
#line 209 "../ssh/source.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 209 "../ssh/source.vala"
		if (_data_->_state_ != 0) {
#line 209 "../ssh/source.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 209 "../ssh/source.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1129 "source.c"
			}
		}
#line 209 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 209 "../ssh/source.vala"
		return FALSE;
#line 1136 "source.c"
	}
	{
#line 212 "../ssh/source.vala"
		_data_->i = (guint) 0;
#line 1141 "source.c"
		{
#line 212 "../ssh/source.vala"
			_data_->_tmp0_ = TRUE;
#line 212 "../ssh/source.vala"
			while (TRUE) {
#line 212 "../ssh/source.vala"
				if (!_data_->_tmp0_) {
#line 212 "../ssh/source.vala"
					_data_->_tmp1_ = _data_->i;
#line 212 "../ssh/source.vala"
					_data_->i = _data_->_tmp1_ + 1;
#line 1153 "source.c"
				}
#line 212 "../ssh/source.vala"
				_data_->_tmp0_ = FALSE;
#line 212 "../ssh/source.vala"
				_data_->_tmp2_ = _data_->self->priv->keys;
#line 212 "../ssh/source.vala"
				if (!(_data_->i < g_list_model_get_n_items ((GListModel*) _data_->_tmp2_))) {
#line 212 "../ssh/source.vala"
					break;
#line 1163 "source.c"
				}
#line 213 "../ssh/source.vala"
				_data_->_tmp3_ = _data_->self->priv->keys;
#line 213 "../ssh/source.vala"
				_data_->_tmp4_ = g_list_model_get_item ((GListModel*) _data_->_tmp3_, _data_->i);
#line 213 "../ssh/source.vala"
				_data_->key = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 214 "../ssh/source.vala"
				_data_->_tmp5_ = _data_->key;
#line 214 "../ssh/source.vala"
				_data_->_tmp6_ = seahorse_ssh_key_get_key_data (_data_->_tmp5_);
#line 214 "../ssh/source.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 214 "../ssh/source.vala"
				_data_->_tmp8_ = seahorse_ssh_key_data_get_privfile (_data_->_tmp7_);
#line 214 "../ssh/source.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 214 "../ssh/source.vala"
				if (g_strcmp0 (_data_->_tmp9_, _data_->privfile) == 0) {
#line 215 "../ssh/source.vala"
					_data_->result = _data_->key;
#line 215 "../ssh/source.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 215 "../ssh/source.vala"
					if (_data_->_state_ != 0) {
#line 215 "../ssh/source.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 215 "../ssh/source.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1193 "source.c"
						}
					}
#line 215 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 215 "../ssh/source.vala"
					return FALSE;
#line 1200 "source.c"
				}
#line 212 "../ssh/source.vala"
				_g_object_unref0 (_data_->key);
#line 1204 "source.c"
			}
		}
	}
#line 219 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 219 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file (_data_->self, _data_->privfile, seahorse_ssh_source_add_key_from_filename_ready, _data_);
#line 219 "../ssh/source.vala"
	return FALSE;
#line 1214 "source.c"
	_state_1:
#line 219 "../ssh/source.vala"
	_data_->_tmp11_ = seahorse_ssh_source_load_key_for_private_file_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 219 "../ssh/source.vala"
	_data_->_tmp10_ = _data_->_tmp11_;
#line 219 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 219 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 219 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 219 "../ssh/source.vala"
		return FALSE;
#line 1228 "source.c"
	}
#line 219 "../ssh/source.vala"
	_data_->_tmp12_ = _data_->_tmp10_;
#line 219 "../ssh/source.vala"
	_data_->_tmp10_ = NULL;
#line 219 "../ssh/source.vala"
	_data_->result = _data_->_tmp12_;
#line 219 "../ssh/source.vala"
	_g_object_unref0 (_data_->_tmp10_);
#line 219 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 219 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 219 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 219 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1246 "source.c"
		}
	}
#line 219 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 219 "../ssh/source.vala"
	return FALSE;
#line 1253 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file_data_free (gpointer _data)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceLoadKeyForPrivateFileData, _data_);
#line 1267 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file (SeahorseSshSource* self,
                                               const gchar* privfile,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
	SeahorseSshSource* _tmp0_;
	gchar* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (privfile != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceLoadKeyForPrivateFileData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_load_key_for_private_file_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = g_strdup (privfile);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_data_->privfile = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file_co (_data_);
#line 1301 "source.c"
}

static SeahorseSshKey*
seahorse_ssh_source_load_key_for_private_file_finish (SeahorseSshSource* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	SeahorseSshKey* result;
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 1317 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 1325 "source.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 223 "../ssh/source.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 223 "../ssh/source.vala"
	return _data10_;
#line 1335 "source.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 223 "../ssh/source.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1345 "source.c"
		SeahorseSshSource* self;
#line 223 "../ssh/source.vala"
		self = _data10_->self;
#line 223 "../ssh/source.vala"
		_g_object_unref0 (_data10_->key);
#line 223 "../ssh/source.vala"
		_g_free0 (_data10_->pubfile);
#line 223 "../ssh/source.vala"
		_g_free0 (_data10_->privfile);
#line 223 "../ssh/source.vala"
		_g_object_unref0 (self);
#line 223 "../ssh/source.vala"
		g_slice_free (Block10Data, _data10_);
#line 1359 "source.c"
	}
}

static gboolean
____lambda16_ (Block10Data* _data10_,
               SeahorseSshKeyData* keydata)
{
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	SeahorseSshKey* _tmp1_;
	gboolean result = FALSE;
#line 232 "../ssh/source.vala"
	self = _data10_->self;
#line 232 "../ssh/source.vala"
	g_return_val_if_fail (keydata != NULL, FALSE);
#line 233 "../ssh/source.vala"
	_tmp0_ = _data10_->pubfile;
#line 233 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_source_add_key_from_parsed_data (self, keydata, _tmp0_, FALSE, FALSE, _data10_->privfile, NULL);
#line 233 "../ssh/source.vala"
	_g_object_unref0 (_data10_->key);
#line 233 "../ssh/source.vala"
	_data10_->key = _tmp1_;
#line 234 "../ssh/source.vala"
	result = TRUE;
#line 234 "../ssh/source.vala"
	return result;
#line 1387 "source.c"
}

static gboolean
_____lambda16__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                    gpointer self)
{
	gboolean result;
	result = ____lambda16_ (self, data);
#line 232 "../ssh/source.vala"
	return result;
#line 1398 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
#line 232 "../ssh/source.vala"
	_data_ = _user_data_;
#line 232 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 232 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 232 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file_co (_data_);
#line 1415 "source.c"
}

static gboolean
seahorse_ssh_source_load_key_for_private_file_co (SeahorseSshSourceLoadKeyForPrivateFileData* _data_)
{
#line 223 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 223 "../ssh/source.vala"
		case 0:
#line 1425 "source.c"
		goto _state_0;
#line 223 "../ssh/source.vala"
		case 1:
#line 1429 "source.c"
		goto _state_1;
		default:
#line 223 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1434 "source.c"
	}
	_state_0:
#line 223 "../ssh/source.vala"
	_data_->_data10_ = g_slice_new0 (Block10Data);
#line 223 "../ssh/source.vala"
	_data_->_data10_->_ref_count_ = 1;
#line 223 "../ssh/source.vala"
	_data_->_data10_->self = g_object_ref (_data_->self);
#line 223 "../ssh/source.vala"
	_g_free0 (_data_->_data10_->privfile);
#line 223 "../ssh/source.vala"
	_data_->_data10_->privfile = _data_->privfile;
#line 223 "../ssh/source.vala"
	_data_->_data10_->_async_data_ = _data_;
#line 224 "../ssh/source.vala"
	_data_->_tmp0_ = g_strconcat (_data_->_data10_->privfile, ".pub", NULL);
#line 224 "../ssh/source.vala"
	_data_->_data10_->pubfile = _data_->_tmp0_;
#line 225 "../ssh/source.vala"
	_data_->_data10_->key = NULL;
#line 228 "../ssh/source.vala"
	if (g_file_test (_data_->_data10_->privfile, G_FILE_TEST_EXISTS)) {
#line 229 "../ssh/source.vala"
		_data_->_tmp3_ = _data_->_data10_->pubfile;
#line 229 "../ssh/source.vala"
		_data_->_tmp2_ = g_file_test (_data_->_tmp3_, G_FILE_TEST_EXISTS);
#line 1461 "source.c"
	} else {
#line 228 "../ssh/source.vala"
		_data_->_tmp2_ = FALSE;
#line 1465 "source.c"
	}
#line 228 "../ssh/source.vala"
	if (_data_->_tmp2_) {
#line 230 "../ssh/source.vala"
		_data_->_tmp1_ = seahorse_ssh_source_check_file_for_ssh (_data_->self, _data_->_data10_->privfile);
#line 1471 "source.c"
	} else {
#line 228 "../ssh/source.vala"
		_data_->_tmp1_ = FALSE;
#line 1475 "source.c"
	}
#line 228 "../ssh/source.vala"
	if (_data_->_tmp1_) {
#line 1479 "source.c"
		{
#line 232 "../ssh/source.vala"
			_data_->_tmp4_ = _data_->_data10_->pubfile;
#line 232 "../ssh/source.vala"
			_data_->_state_ = 1;
#line 232 "../ssh/source.vala"
			seahorse_ssh_key_parse_file (_data_->_tmp4_, _____lambda16__seahorse_ssh_key_pub_parsed_handler, _data_->_data10_, NULL, NULL, NULL, seahorse_ssh_source_load_key_for_private_file_ready, _data_);
#line 232 "../ssh/source.vala"
			return FALSE;
#line 1489 "source.c"
			_state_1:
#line 232 "../ssh/source.vala"
			seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_inner_error0_);
#line 232 "../ssh/source.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1495 "source.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 231 "../ssh/source.vala"
			_data_->e = _data_->_inner_error0_;
#line 231 "../ssh/source.vala"
			_data_->_inner_error0_ = NULL;
#line 237 "../ssh/source.vala"
			_data_->_tmp5_ = _data_->_data10_->pubfile;
#line 237 "../ssh/source.vala"
			_data_->_tmp6_ = _data_->e;
#line 237 "../ssh/source.vala"
			_data_->_tmp7_ = _data_->_tmp6_->message;
#line 237 "../ssh/source.vala"
			_data_->_tmp8_ = g_strdup_printf ("Couldn't read SSH file: %s (%s)", _data_->_tmp5_, _data_->_tmp7_);
#line 237 "../ssh/source.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 237 "../ssh/source.vala"
			_data_->_tmp10_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _data_->_tmp9_);
#line 237 "../ssh/source.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 237 "../ssh/source.vala"
			_g_free0 (_data_->_tmp9_);
#line 237 "../ssh/source.vala"
			_data_->_inner_error0_ = _data_->_tmp11_;
#line 237 "../ssh/source.vala"
			_g_error_free0 (_data_->e);
#line 1526 "source.c"
			goto __finally0;
		}
		__finally0:
#line 231 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 231 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 231 "../ssh/source.vala"
			block10_data_unref (_data_->_data10_);
#line 231 "../ssh/source.vala"
			_data_->_data10_ = NULL;
#line 231 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 231 "../ssh/source.vala"
			return FALSE;
#line 1542 "source.c"
		}
	}
#line 241 "../ssh/source.vala"
	_data_->_tmp12_ = _data_->_data10_->key;
#line 241 "../ssh/source.vala"
	_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp12_);
#line 241 "../ssh/source.vala"
	_data_->result = _data_->_tmp13_;
#line 241 "../ssh/source.vala"
	block10_data_unref (_data_->_data10_);
#line 241 "../ssh/source.vala"
	_data_->_data10_ = NULL;
#line 241 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 241 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 241 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 241 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1563 "source.c"
		}
	}
#line 241 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 241 "../ssh/source.vala"
	return FALSE;
#line 1570 "source.c"
}

gchar*
seahorse_ssh_source_export_private (SeahorseSshSource* self,
                                    SeahorseSshKey* key,
                                    GError** error)
{
	SeahorseSshKeyData* keydata = NULL;
	SeahorseSshKeyData* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	SeahorseSshKeyData* _tmp2_;
	SeahorseSshKeyData* _tmp3_;
	SeahorseSshKeyData* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* results = NULL;
	gboolean _tmp8_ = FALSE;
	SeahorseSshKeyData* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 244 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 244 "../ssh/source.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 245 "../ssh/source.vala"
	_tmp0_ = seahorse_ssh_key_get_key_data (key);
#line 245 "../ssh/source.vala"
	_tmp1_ = _tmp0_;
#line 245 "../ssh/source.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 245 "../ssh/source.vala"
	keydata = _tmp2_;
#line 246 "../ssh/source.vala"
	_tmp3_ = keydata;
#line 246 "../ssh/source.vala"
	if (_tmp3_ == NULL) {
#line 247 "../ssh/source.vala"
		result = NULL;
#line 247 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 247 "../ssh/source.vala"
		return result;
#line 1617 "source.c"
	}
#line 249 "../ssh/source.vala"
	_tmp4_ = keydata;
#line 249 "../ssh/source.vala"
	_tmp5_ = seahorse_ssh_key_data_get_privfile (_tmp4_);
#line 249 "../ssh/source.vala"
	_tmp6_ = _tmp5_;
#line 249 "../ssh/source.vala"
	if (_tmp6_ == NULL) {
#line 1627 "source.c"
		GError* _tmp7_;
#line 250 "../ssh/source.vala"
		_tmp7_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _ ("No private key file is available for this key."));
#line 250 "../ssh/source.vala"
		_inner_error0_ = _tmp7_;
#line 250 "../ssh/source.vala"
		g_propagate_error (error, _inner_error0_);
#line 250 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 250 "../ssh/source.vala"
		return NULL;
#line 1639 "source.c"
	}
#line 254 "../ssh/source.vala"
	_tmp9_ = keydata;
#line 254 "../ssh/source.vala"
	_tmp10_ = seahorse_ssh_key_data_get_privfile (_tmp9_);
#line 254 "../ssh/source.vala"
	_tmp11_ = _tmp10_;
#line 254 "../ssh/source.vala"
	_tmp13_ = g_file_get_contents (_tmp11_, &_tmp12_, NULL, &_inner_error0_);
#line 254 "../ssh/source.vala"
	_g_free0 (results);
#line 254 "../ssh/source.vala"
	results = _tmp12_;
#line 254 "../ssh/source.vala"
	_tmp8_ = _tmp13_;
#line 254 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../ssh/source.vala"
		g_propagate_error (error, _inner_error0_);
#line 254 "../ssh/source.vala"
		_g_free0 (results);
#line 254 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 254 "../ssh/source.vala"
		return NULL;
#line 1665 "source.c"
	}
#line 254 "../ssh/source.vala"
	if (!_tmp8_) {
#line 255 "../ssh/source.vala"
		result = NULL;
#line 255 "../ssh/source.vala"
		_g_free0 (results);
#line 255 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 255 "../ssh/source.vala"
		return result;
#line 1677 "source.c"
	}
#line 257 "../ssh/source.vala"
	result = results;
#line 257 "../ssh/source.vala"
	_g_object_unref0 (keydata);
#line 257 "../ssh/source.vala"
	return result;
#line 1685 "source.c"
}

static void
seahorse_ssh_source_real_load_data_free (gpointer _data)
{
	SeahorseSshSourceLoadData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceLoadData, _data_);
#line 1699 "source.c"
}

static void
seahorse_ssh_source_real_load (SeahorsePlace* base,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	SeahorseSshSource * self;
	SeahorseSshSourceLoadData* _data_;
	SeahorseSshSource* _tmp0_;
	GCancellable* _tmp1_;
#line 26 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceLoadData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_real_load_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_real_load_co (_data_);
#line 1732 "source.c"
}

static gboolean
seahorse_ssh_source_load_finish (SeahorsePlace* base,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	gboolean result;
	SeahorseSshSourceLoadData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 1746 "source.c"
		gboolean _tmp0_ = FALSE;
#line 26 "../ssh/source.vala"
		return _tmp0_;
#line 1750 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	return result;
#line 1756 "source.c"
}

/**
     * Loads the keys from this Source's directory.
     *
     * @param cancellable Use this to cancel the operation.
     */
static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 265 "../ssh/source.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 265 "../ssh/source.vala"
	return _data11_;
#line 1771 "source.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 265 "../ssh/source.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 1781 "source.c"
		SeahorseSshSource* self;
#line 265 "../ssh/source.vala"
		self = _data11_->self;
#line 265 "../ssh/source.vala"
		_g_free0 (_data11_->pubfile);
#line 265 "../ssh/source.vala"
		_g_object_unref0 (self);
#line 265 "../ssh/source.vala"
		g_slice_free (Block11Data, _data11_);
#line 1791 "source.c"
	}
}

static gboolean
_seahorse_ssh_source_scheduled_dummy_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_scheduled_dummy ((SeahorseSshSource*) self);
#line 268 "../ssh/source.vala"
	return result;
#line 1802 "source.c"
}

static gboolean
__lambda17_ (Block11Data* _data11_,
             SeahorseSshKeyData* keydata)
{
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	SeahorseSshKey* _tmp1_;
	SeahorseSshKey* _tmp2_;
	gboolean result = FALSE;
#line 283 "../ssh/source.vala"
	self = _data11_->self;
#line 283 "../ssh/source.vala"
	g_return_val_if_fail (keydata != NULL, FALSE);
#line 284 "../ssh/source.vala"
	_tmp0_ = _data11_->pubfile;
#line 284 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_source_add_key_from_parsed_data (self, keydata, _tmp0_, TRUE, TRUE, NULL, NULL);
#line 284 "../ssh/source.vala"
	_tmp2_ = _tmp1_;
#line 284 "../ssh/source.vala"
	_g_object_unref0 (_tmp2_);
#line 285 "../ssh/source.vala"
	result = TRUE;
#line 285 "../ssh/source.vala"
	return result;
#line 1830 "source.c"
}

static gboolean
___lambda17__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                  gpointer self)
{
	gboolean result;
	result = __lambda17_ (self, data);
#line 283 "../ssh/source.vala"
	return result;
#line 1841 "source.c"
}

static gboolean
__lambda18_ (Block11Data* _data11_,
             SeahorseSshKeyData* keydata)
{
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	SeahorseSshKey* _tmp1_;
	SeahorseSshKey* _tmp2_;
	gboolean result = FALSE;
#line 290 "../ssh/source.vala"
	self = _data11_->self;
#line 290 "../ssh/source.vala"
	g_return_val_if_fail (keydata != NULL, FALSE);
#line 291 "../ssh/source.vala"
	_tmp0_ = _data11_->pubfile;
#line 291 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_source_add_key_from_parsed_data (self, keydata, _tmp0_, TRUE, FALSE, NULL, NULL);
#line 291 "../ssh/source.vala"
	_tmp2_ = _tmp1_;
#line 291 "../ssh/source.vala"
	_g_object_unref0 (_tmp2_);
#line 292 "../ssh/source.vala"
	result = TRUE;
#line 292 "../ssh/source.vala"
	return result;
#line 1869 "source.c"
}

static gboolean
___lambda18__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                  gpointer self)
{
	gboolean result;
	result = __lambda18_ (self, data);
#line 290 "../ssh/source.vala"
	return result;
#line 1880 "source.c"
}

static gboolean
seahorse_ssh_source_real_load_co (SeahorseSshSourceLoadData* _data_)
{
#line 265 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 265 "../ssh/source.vala"
		case 0:
#line 1890 "source.c"
		goto _state_0;
		default:
#line 265 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1895 "source.c"
	}
	_state_0:
#line 265 "../ssh/source.vala"
	_data_->_data11_ = g_slice_new0 (Block11Data);
#line 265 "../ssh/source.vala"
	_data_->_data11_->_ref_count_ = 1;
#line 265 "../ssh/source.vala"
	_data_->_data11_->self = g_object_ref (_data_->self);
#line 265 "../ssh/source.vala"
	_data_->_data11_->_async_data_ = _data_;
#line 267 "../ssh/source.vala"
	seahorse_ssh_source_cancel_scheduled_refresh (_data_->self);
#line 268 "../ssh/source.vala"
	_data_->self->priv->scheduled_refresh_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _seahorse_ssh_source_scheduled_dummy_gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 269 "../ssh/source.vala"
	g_debug ("source.vala:269: scheduled a dummy refresh");
#line 272 "../ssh/source.vala"
	_data_->_tmp0_ = _data_->self->priv->ssh_homedir;
#line 272 "../ssh/source.vala"
	_data_->_tmp1_ = g_dir_open (_data_->_tmp0_, (guint) 0, &_data_->_inner_error0_);
#line 272 "../ssh/source.vala"
	_data_->dir = _data_->_tmp1_;
#line 272 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 272 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 272 "../ssh/source.vala"
		block11_data_unref (_data_->_data11_);
#line 272 "../ssh/source.vala"
		_data_->_data11_ = NULL;
#line 272 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 272 "../ssh/source.vala"
		return FALSE;
#line 1930 "source.c"
	}
#line 275 "../ssh/source.vala"
	_data_->filename = NULL;
#line 276 "../ssh/source.vala"
	while (TRUE) {
#line 276 "../ssh/source.vala"
		_data_->_tmp2_ = g_dir_read_name (_data_->dir);
#line 276 "../ssh/source.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp2_);
#line 276 "../ssh/source.vala"
		_g_free0 (_data_->filename);
#line 276 "../ssh/source.vala"
		_data_->filename = _data_->_tmp3_;
#line 276 "../ssh/source.vala"
		_data_->_tmp4_ = _data_->filename;
#line 276 "../ssh/source.vala"
		if (!(_data_->_tmp4_ != NULL)) {
#line 276 "../ssh/source.vala"
			break;
#line 1950 "source.c"
		}
#line 277 "../ssh/source.vala"
		_data_->_tmp5_ = _data_->self->priv->ssh_homedir;
#line 277 "../ssh/source.vala"
		_data_->_tmp6_ = _data_->filename;
#line 277 "../ssh/source.vala"
		_data_->_tmp7_ = g_build_filename (_data_->_tmp5_, _data_->_tmp6_, NULL);
#line 277 "../ssh/source.vala"
		_data_->privfile = _data_->_tmp7_;
#line 278 "../ssh/source.vala"
		_data_->_tmp8_ = _data_->privfile;
#line 278 "../ssh/source.vala"
		seahorse_ssh_source_load_key_for_private_file (_data_->self, _data_->_tmp8_, NULL, NULL);
#line 276 "../ssh/source.vala"
		_g_free0 (_data_->privfile);
#line 1966 "source.c"
	}
#line 282 "../ssh/source.vala"
	_data_->_tmp9_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 282 "../ssh/source.vala"
	_data_->_data11_->pubfile = _data_->_tmp9_;
#line 283 "../ssh/source.vala"
	_data_->_tmp10_ = _data_->_data11_->pubfile;
#line 283 "../ssh/source.vala"
	seahorse_ssh_key_parse_file (_data_->_tmp10_, ___lambda17__seahorse_ssh_key_pub_parsed_handler, _data_->_data11_, NULL, NULL, NULL, NULL, NULL);
#line 289 "../ssh/source.vala"
	_data_->_tmp11_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 289 "../ssh/source.vala"
	_g_free0 (_data_->_data11_->pubfile);
#line 289 "../ssh/source.vala"
	_data_->_data11_->pubfile = _data_->_tmp11_;
#line 290 "../ssh/source.vala"
	_data_->_tmp12_ = _data_->_data11_->pubfile;
#line 290 "../ssh/source.vala"
	seahorse_ssh_key_parse_file (_data_->_tmp12_, ___lambda18__seahorse_ssh_key_pub_parsed_handler, _data_->_data11_, NULL, NULL, NULL, NULL, NULL);
#line 295 "../ssh/source.vala"
	_data_->result = TRUE;
#line 295 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 295 "../ssh/source.vala"
	_g_dir_close0 (_data_->dir);
#line 295 "../ssh/source.vala"
	block11_data_unref (_data_->_data11_);
#line 295 "../ssh/source.vala"
	_data_->_data11_ = NULL;
#line 295 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 295 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 295 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 295 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2004 "source.c"
		}
	}
#line 295 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 295 "../ssh/source.vala"
	return FALSE;
#line 2011 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_add_key_from_parsed_data (SeahorseSshSource* src,
                                              SeahorseSshKeyData* keydata,
                                              const gchar* pubfile,
                                              gboolean partial,
                                              gboolean authorized,
                                              const gchar* privfile,
                                              GPtrArray* checks)
{
	gboolean _tmp0_ = FALSE;
	SeahorseSshKey* prev = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	SeahorseSshKey* _tmp5_;
	SeahorseSshKey* _tmp6_;
	SeahorseSshKey* _tmp8_;
	SeahorseSshKey* key = NULL;
	SeahorseSshKey* _tmp9_;
	GListStore* _tmp10_;
	SeahorseSshKey* _tmp11_;
	SeahorseSshKey* _tmp12_;
	SeahorseSshKey* result = NULL;
#line 298 "../ssh/source.vala"
	g_return_val_if_fail (src != NULL, NULL);
#line 298 "../ssh/source.vala"
	g_return_val_if_fail (pubfile != NULL, NULL);
#line 305 "../ssh/source.vala"
	if (keydata != NULL) {
#line 305 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_key_data_is_valid (keydata);
#line 2044 "source.c"
	} else {
#line 305 "../ssh/source.vala"
		_tmp0_ = FALSE;
#line 2048 "source.c"
	}
#line 305 "../ssh/source.vala"
	g_return_val_if_fail (_tmp0_, NULL);
#line 307 "../ssh/source.vala"
	seahorse_ssh_key_data_set_pubfile (keydata, pubfile);
#line 308 "../ssh/source.vala"
	seahorse_ssh_key_data_set_partial (keydata, partial);
#line 309 "../ssh/source.vala"
	seahorse_ssh_key_data_set_authorized (keydata, authorized);
#line 310 "../ssh/source.vala"
	if (privfile != NULL) {
#line 311 "../ssh/source.vala"
		seahorse_ssh_key_data_set_privfile (keydata, privfile);
#line 2062 "source.c"
	}
#line 314 "../ssh/source.vala"
	if (checks != NULL) {
#line 2066 "source.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 315 "../ssh/source.vala"
		_tmp1_ = seahorse_ssh_key_data_get_fingerprint (keydata);
#line 315 "../ssh/source.vala"
		_tmp2_ = _tmp1_;
#line 315 "../ssh/source.vala"
		g_ptr_array_remove (checks, _tmp2_);
#line 2075 "source.c"
	}
#line 318 "../ssh/source.vala"
	_tmp3_ = seahorse_ssh_key_data_get_fingerprint (keydata);
#line 318 "../ssh/source.vala"
	_tmp4_ = _tmp3_;
#line 318 "../ssh/source.vala"
	_tmp5_ = seahorse_ssh_source_find_key_by_fingerprint (src, _tmp4_);
#line 318 "../ssh/source.vala"
	prev = _tmp5_;
#line 319 "../ssh/source.vala"
	_tmp6_ = prev;
#line 319 "../ssh/source.vala"
	if (_tmp6_ != NULL) {
#line 2089 "source.c"
		SeahorseSshKey* _tmp7_;
#line 320 "../ssh/source.vala"
		_tmp7_ = prev;
#line 320 "../ssh/source.vala"
		seahorse_ssh_key_merge_keydata (_tmp7_, keydata);
#line 2095 "source.c"
	}
#line 323 "../ssh/source.vala"
	_tmp8_ = prev;
#line 323 "../ssh/source.vala"
	if (_tmp8_ != NULL) {
#line 324 "../ssh/source.vala"
		result = prev;
#line 324 "../ssh/source.vala"
		return result;
#line 2105 "source.c"
	}
#line 327 "../ssh/source.vala"
	_tmp9_ = seahorse_ssh_key_new (src, keydata);
#line 327 "../ssh/source.vala"
	key = _tmp9_;
#line 328 "../ssh/source.vala"
	_tmp10_ = src->priv->keys;
#line 328 "../ssh/source.vala"
	_tmp11_ = key;
#line 328 "../ssh/source.vala"
	g_list_store_append (_tmp10_, (GObject*) _tmp11_);
#line 329 "../ssh/source.vala"
	_tmp12_ = key;
#line 329 "../ssh/source.vala"
	g_signal_emit_by_name ((GcrCollection*) src, "added", (GObject*) _tmp12_);
#line 331 "../ssh/source.vala"
	result = key;
#line 331 "../ssh/source.vala"
	_g_object_unref0 (prev);
#line 331 "../ssh/source.vala"
	return result;
#line 2127 "source.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 26 "../ssh/source.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2135 "source.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 26 "../ssh/source.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2143 "source.c"
}

static void
seahorse_ssh_source_import_async_data_free (gpointer _data)
{
	SeahorseSshSourceImportAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->input);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->transient_for);
#line 26 "../ssh/source.vala"
	(_data_->result == NULL) ? NULL : (_data_->result = (_g_list_free__g_object_unref0_ (_data_->result), NULL));
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceImportAsyncData, _data_);
#line 2161 "source.c"
}

void
seahorse_ssh_source_import_async (SeahorseSshSource* self,
                                  GInputStream* input,
                                  GtkWindow* transient_for,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	SeahorseSshSourceImportAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	GInputStream* _tmp1_;
	GtkWindow* _tmp2_;
	GCancellable* _tmp3_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (input != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (transient_for != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceImportAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_import_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (input);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->input);
#line 26 "../ssh/source.vala"
	_data_->input = _tmp1_;
#line 26 "../ssh/source.vala"
	_tmp2_ = _g_object_ref0 (transient_for);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->transient_for);
#line 26 "../ssh/source.vala"
	_data_->transient_for = _tmp2_;
#line 26 "../ssh/source.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp3_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_import_async_co (_data_);
#line 2213 "source.c"
}

GList*
seahorse_ssh_source_import_finish (SeahorseSshSource* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	GList* result;
	SeahorseSshSourceImportAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 2229 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 2237 "source.c"
}

/**
     * Parse an inputstream into a list of keys and import those keys.
     */
static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 338 "../ssh/source.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 338 "../ssh/source.vala"
	return _data12_;
#line 2250 "source.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 338 "../ssh/source.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 2260 "source.c"
		SeahorseSshSource* self;
#line 338 "../ssh/source.vala"
		self = _data12_->self;
#line 338 "../ssh/source.vala"
		_g_object_unref0 (_data12_->src);
#line 338 "../ssh/source.vala"
		_g_free0 (_data12_->fullpath);
#line 338 "../ssh/source.vala"
		_g_object_unref0 (_data12_->cancellable);
#line 338 "../ssh/source.vala"
		_g_object_unref0 (self);
#line 338 "../ssh/source.vala"
		g_slice_free (Block12Data, _data12_);
#line 2274 "source.c"
	}
}

static gboolean
__lambda20_ (Block12Data* _data12_,
             SeahorseSshKeyData* keydata)
{
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gboolean result = FALSE;
#line 348 "../ssh/source.vala"
	self = _data12_->self;
#line 348 "../ssh/source.vala"
	g_return_val_if_fail (keydata != NULL, FALSE);
#line 349 "../ssh/source.vala"
	_tmp0_ = _data12_->fullpath;
#line 349 "../ssh/source.vala"
	seahorse_ssh_source_import_public_async (self, keydata, _tmp0_, _data12_->cancellable, NULL, NULL);
#line 350 "../ssh/source.vala"
	result = TRUE;
#line 350 "../ssh/source.vala"
	return result;
#line 2297 "source.c"
}

static gboolean
___lambda20__seahorse_ssh_key_pub_parsed_handler (SeahorseSshKeyData* data,
                                                  gpointer self)
{
	gboolean result;
	result = __lambda20_ (self, data);
#line 347 "../ssh/source.vala"
	return result;
#line 2308 "source.c"
}

static gboolean
__lambda21_ (Block12Data* _data12_,
             SeahorseSshSecData* secdata)
{
	SeahorseSshSource* self;
	SeahorseSshPrivateImportOperation* _tmp0_;
	SeahorseSshPrivateImportOperation* _tmp1_;
	SeahorseSshSource* _tmp2_;
	gboolean result = FALSE;
#line 352 "../ssh/source.vala"
	self = _data12_->self;
#line 352 "../ssh/source.vala"
	g_return_val_if_fail (secdata != NULL, FALSE);
#line 353 "../ssh/source.vala"
	_tmp0_ = seahorse_ssh_private_import_operation_new ();
#line 353 "../ssh/source.vala"
	_tmp1_ = _tmp0_;
#line 353 "../ssh/source.vala"
	_tmp2_ = _data12_->src;
#line 353 "../ssh/source.vala"
	seahorse_ssh_private_import_operation_import_private_async (_tmp1_, _tmp2_, secdata, NULL, _data12_->cancellable, NULL, NULL);
#line 353 "../ssh/source.vala"
	_g_object_unref0 (_tmp1_);
#line 354 "../ssh/source.vala"
	result = TRUE;
#line 354 "../ssh/source.vala"
	return result;
#line 2338 "source.c"
}

static gboolean
___lambda21__seahorse_ssh_key_priv_parsed_handler (SeahorseSshSecData* data,
                                                   gpointer self)
{
	gboolean result;
	result = __lambda21_ (self, data);
#line 347 "../ssh/source.vala"
	return result;
#line 2349 "source.c"
}

static gboolean
seahorse_ssh_source_import_async_co (SeahorseSshSourceImportAsyncData* _data_)
{
#line 338 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 338 "../ssh/source.vala"
		case 0:
#line 2359 "source.c"
		goto _state_0;
		default:
#line 338 "../ssh/source.vala"
		g_assert_not_reached ();
#line 2364 "source.c"
	}
	_state_0:
#line 338 "../ssh/source.vala"
	_data_->_data12_ = g_slice_new0 (Block12Data);
#line 338 "../ssh/source.vala"
	_data_->_data12_->_ref_count_ = 1;
#line 338 "../ssh/source.vala"
	_data_->_data12_->self = g_object_ref (_data_->self);
#line 338 "../ssh/source.vala"
	_g_object_unref0 (_data_->_data12_->cancellable);
#line 338 "../ssh/source.vala"
	_data_->_data12_->cancellable = _data_->cancellable;
#line 338 "../ssh/source.vala"
	_data_->_data12_->_async_data_ = _data_;
#line 340 "../ssh/source.vala"
	_data_->_tmp0_ = g_new0 (guint8, 4096);
#line 340 "../ssh/source.vala"
	_data_->buffer = _data_->_tmp0_;
#line 340 "../ssh/source.vala"
	_data_->buffer_length1 = 4096;
#line 340 "../ssh/source.vala"
	_data_->_buffer_size_ = _data_->buffer_length1;
#line 342 "../ssh/source.vala"
	_data_->_tmp1_ = 0UL;
#line 342 "../ssh/source.vala"
	g_input_stream_read_all (_data_->input, _data_->buffer, (gsize) _data_->buffer_length1, &_data_->_tmp1_, _data_->_data12_->cancellable, &_data_->_inner_error0_);
#line 342 "../ssh/source.vala"
	_data_->bytes_read = _data_->_tmp1_;
#line 342 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 342 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 342 "../ssh/source.vala"
		_data_->buffer = (g_free (_data_->buffer), NULL);
#line 342 "../ssh/source.vala"
		block12_data_unref (_data_->_data12_);
#line 342 "../ssh/source.vala"
		_data_->_data12_ = NULL;
#line 342 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 342 "../ssh/source.vala"
		return FALSE;
#line 2407 "source.c"
	}
#line 344 "../ssh/source.vala"
	_data_->_tmp2_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 344 "../ssh/source.vala"
	_data_->_data12_->fullpath = _data_->_tmp2_;
#line 345 "../ssh/source.vala"
	_data_->_tmp3_ = _g_object_ref0 (_data_->self);
#line 345 "../ssh/source.vala"
	_data_->_data12_->src = _data_->_tmp3_;
#line 347 "../ssh/source.vala"
	seahorse_ssh_key_parse ((const gchar*) _data_->buffer, ___lambda20__seahorse_ssh_key_pub_parsed_handler, _data_->_data12_, ___lambda21__seahorse_ssh_key_priv_parsed_handler, _data_->_data12_, NULL, NULL, NULL);
#line 358 "../ssh/source.vala"
	_data_->result = NULL;
#line 358 "../ssh/source.vala"
	_data_->buffer = (g_free (_data_->buffer), NULL);
#line 358 "../ssh/source.vala"
	block12_data_unref (_data_->_data12_);
#line 358 "../ssh/source.vala"
	_data_->_data12_ = NULL;
#line 358 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 358 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 358 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 358 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2435 "source.c"
		}
	}
#line 358 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 358 "../ssh/source.vala"
	return FALSE;
#line 2442 "source.c"
}

static void
seahorse_ssh_source_import_public_async_data_free (gpointer _data)
{
	SeahorseSshSourceImportPublicAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->data);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceImportPublicAsyncData, _data_);
#line 2462 "source.c"
}

void
seahorse_ssh_source_import_public_async (SeahorseSshSource* self,
                                         SeahorseSshKeyData* data,
                                         const gchar* filename,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	SeahorseSshSourceImportPublicAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (data != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (filename != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceImportPublicAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_import_public_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (data);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->data);
#line 26 "../ssh/source.vala"
	_data_->data = _tmp1_;
#line 26 "../ssh/source.vala"
	_tmp2_ = g_strdup (filename);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 26 "../ssh/source.vala"
	_data_->filename = _tmp2_;
#line 26 "../ssh/source.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp3_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_import_public_async_co (_data_);
#line 2514 "source.c"
}

gchar*
seahorse_ssh_source_import_public_finish (SeahorseSshSource* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	gchar* result;
	SeahorseSshSourceImportPublicAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 2530 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 2538 "source.c"
}

/**
     * Import a public key into a file.
     *
     * @param data The public key that needs to be imported.
     * @param filename The name of the file in which the key should be imported.
     * @param cancellable Allows the operation to be cancelled.
     */
static gboolean
seahorse_ssh_source_import_public_async_co (SeahorseSshSourceImportPublicAsyncData* _data_)
{
#line 368 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 368 "../ssh/source.vala"
		case 0:
#line 2555 "source.c"
		goto _state_0;
		default:
#line 368 "../ssh/source.vala"
		g_assert_not_reached ();
#line 2560 "source.c"
	}
	_state_0:
#line 371 "../ssh/source.vala"
	if (_data_->data == NULL) {
#line 371 "../ssh/source.vala"
		_data_->_tmp1_ = TRUE;
#line 2567 "source.c"
	} else {
#line 371 "../ssh/source.vala"
		_data_->_tmp1_ = !seahorse_ssh_key_data_is_valid (_data_->data);
#line 2571 "source.c"
	}
#line 371 "../ssh/source.vala"
	if (_data_->_tmp1_) {
#line 371 "../ssh/source.vala"
		_data_->_tmp0_ = TRUE;
#line 2577 "source.c"
	} else {
#line 371 "../ssh/source.vala"
		_data_->_tmp2_ = seahorse_ssh_key_data_get_rawdata (_data_->data);
#line 371 "../ssh/source.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 371 "../ssh/source.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 2585 "source.c"
	}
#line 371 "../ssh/source.vala"
	if (_data_->_tmp0_) {
#line 372 "../ssh/source.vala"
		_data_->_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Trying to import an invalid public key.");
#line 372 "../ssh/source.vala"
		_data_->_inner_error0_ = _data_->_tmp4_;
#line 372 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 372 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 372 "../ssh/source.vala"
		return FALSE;
#line 2599 "source.c"
	}
#line 374 "../ssh/source.vala"
	seahorse_ssh_key_data_filter_file (_data_->filename, _data_->data, NULL, &_data_->_inner_error0_);
#line 374 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 374 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 374 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 374 "../ssh/source.vala"
		return FALSE;
#line 2611 "source.c"
	}
#line 376 "../ssh/source.vala"
	_data_->_tmp5_ = seahorse_ssh_key_data_get_fingerprint (_data_->data);
#line 376 "../ssh/source.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 376 "../ssh/source.vala"
	_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 376 "../ssh/source.vala"
	_data_->result = _data_->_tmp7_;
#line 376 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 376 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 376 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 376 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2629 "source.c"
		}
	}
#line 376 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 376 "../ssh/source.vala"
	return FALSE;
#line 2636 "source.c"
}

/**
     * Returns a possible filename for a key.
     *
     * @param algo The type of the key
     */
gchar*
seahorse_ssh_source_new_filename_for_algorithm (SeahorseSshSource* self,
                                                SeahorseSshAlgorithm algo)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* type = NULL;
	gchar* _tmp3_;
	gchar* basename = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* filename = NULL;
	gchar* result = NULL;
#line 384 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 385 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_algorithm_to_string (algo);
#line 385 "../ssh/source.vala"
	_tmp0_ = _tmp1_;
#line 385 "../ssh/source.vala"
	if (_tmp0_ == NULL) {
#line 2668 "source.c"
		gchar* _tmp2_;
#line 385 "../ssh/source.vala"
		_tmp2_ = g_strdup ("unk");
#line 385 "../ssh/source.vala"
		_g_free0 (_tmp0_);
#line 385 "../ssh/source.vala"
		_tmp0_ = _tmp2_;
#line 2676 "source.c"
	}
#line 385 "../ssh/source.vala"
	_tmp3_ = _tmp0_;
#line 385 "../ssh/source.vala"
	_tmp0_ = NULL;
#line 385 "../ssh/source.vala"
	type = _tmp3_;
#line 386 "../ssh/source.vala"
	_tmp4_ = type;
#line 386 "../ssh/source.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 386 "../ssh/source.vala"
	_tmp6_ = _tmp5_;
#line 386 "../ssh/source.vala"
	_tmp7_ = g_strdup_printf ("id_%s", _tmp6_);
#line 386 "../ssh/source.vala"
	_tmp8_ = _tmp7_;
#line 386 "../ssh/source.vala"
	_g_free0 (_tmp6_);
#line 386 "../ssh/source.vala"
	basename = _tmp8_;
#line 388 "../ssh/source.vala"
	filename = NULL;
#line 2700 "source.c"
	{
		gint i = 0;
#line 389 "../ssh/source.vala"
		i = 0;
#line 2705 "source.c"
		{
			gboolean _tmp9_ = FALSE;
#line 389 "../ssh/source.vala"
			_tmp9_ = TRUE;
#line 389 "../ssh/source.vala"
			while (TRUE) {
#line 2712 "source.c"
				gchar* _tmp11_ = NULL;
				gchar* t = NULL;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
#line 389 "../ssh/source.vala"
				if (!_tmp9_) {
#line 2723 "source.c"
					gint _tmp10_;
#line 389 "../ssh/source.vala"
					_tmp10_ = i;
#line 389 "../ssh/source.vala"
					i = _tmp10_ + 1;
#line 2729 "source.c"
				}
#line 389 "../ssh/source.vala"
				_tmp9_ = FALSE;
#line 389 "../ssh/source.vala"
				if (!(i < G_MAXINT)) {
#line 389 "../ssh/source.vala"
					break;
#line 2737 "source.c"
				}
#line 390 "../ssh/source.vala"
				if (i == 0) {
#line 2741 "source.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 390 "../ssh/source.vala"
					_tmp12_ = basename;
#line 390 "../ssh/source.vala"
					_tmp13_ = g_strdup (_tmp12_);
#line 390 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 390 "../ssh/source.vala"
					_tmp11_ = _tmp13_;
#line 2752 "source.c"
				} else {
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 390 "../ssh/source.vala"
					_tmp14_ = basename;
#line 390 "../ssh/source.vala"
					_tmp15_ = g_strdup_printf ("%s.%d", _tmp14_, i);
#line 390 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 390 "../ssh/source.vala"
					_tmp11_ = _tmp15_;
#line 2764 "source.c"
				}
#line 390 "../ssh/source.vala"
				_tmp16_ = g_strdup (_tmp11_);
#line 390 "../ssh/source.vala"
				t = _tmp16_;
#line 391 "../ssh/source.vala"
				_tmp17_ = seahorse_ssh_source_get_base_directory (self);
#line 391 "../ssh/source.vala"
				_tmp18_ = _tmp17_;
#line 391 "../ssh/source.vala"
				_tmp19_ = t;
#line 391 "../ssh/source.vala"
				_tmp20_ = g_build_filename (_tmp18_, _tmp19_, NULL);
#line 391 "../ssh/source.vala"
				_g_free0 (filename);
#line 391 "../ssh/source.vala"
				filename = _tmp20_;
#line 393 "../ssh/source.vala"
				_tmp21_ = filename;
#line 393 "../ssh/source.vala"
				if (!g_file_test (_tmp21_, G_FILE_TEST_EXISTS)) {
#line 394 "../ssh/source.vala"
					_g_free0 (t);
#line 394 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 394 "../ssh/source.vala"
					break;
#line 2792 "source.c"
				}
#line 396 "../ssh/source.vala"
				_g_free0 (filename);
#line 396 "../ssh/source.vala"
				filename = NULL;
#line 389 "../ssh/source.vala"
				_g_free0 (t);
#line 389 "../ssh/source.vala"
				_g_free0 (_tmp11_);
#line 2802 "source.c"
			}
		}
	}
#line 399 "../ssh/source.vala"
	result = filename;
#line 399 "../ssh/source.vala"
	_g_free0 (basename);
#line 399 "../ssh/source.vala"
	_g_free0 (type);
#line 399 "../ssh/source.vala"
	_g_free0 (_tmp0_);
#line 399 "../ssh/source.vala"
	return result;
#line 2816 "source.c"
}

static void
seahorse_ssh_source_authorize_async_data_free (gpointer _data)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceAuthorizeAsyncData, _data_);
#line 2828 "source.c"
}

void
seahorse_ssh_source_authorize_async (SeahorseSshSource* self,
                                     SeahorseSshKey* key,
                                     gboolean authorize,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	SeahorseSshKey* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (key != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceAuthorizeAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_authorize_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (key);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->key);
#line 26 "../ssh/source.vala"
	_data_->key = _tmp1_;
#line 26 "../ssh/source.vala"
	_data_->authorize = authorize;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_authorize_async_co (_data_);
#line 2865 "source.c"
}

void
seahorse_ssh_source_authorize_finish (SeahorseSshSource* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return;
#line 2880 "source.c"
	}
}

/**
     * Adds/Removes a public key to/from the authorized keys.
     *
     * @param key The key that needs to be authorized.
     * @param authorize Whether the specified key needs to be (de-)authorized.
     */
static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 408 "../ssh/source.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 408 "../ssh/source.vala"
	return _data13_;
#line 2897 "source.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 408 "../ssh/source.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 2907 "source.c"
		SeahorseSshSource* self;
#line 408 "../ssh/source.vala"
		self = _data13_->self;
#line 408 "../ssh/source.vala"
		_g_free0 (_data13_->to);
#line 408 "../ssh/source.vala"
		_g_free0 (_data13_->from);
#line 408 "../ssh/source.vala"
		_g_error_free0 (_data13_->err);
#line 408 "../ssh/source.vala"
		(_data13_->callback_target_destroy_notify == NULL) ? NULL : (_data13_->callback_target_destroy_notify (_data13_->callback_target), NULL);
#line 408 "../ssh/source.vala"
		_data13_->callback = NULL;
#line 408 "../ssh/source.vala"
		_data13_->callback_target = NULL;
#line 408 "../ssh/source.vala"
		_data13_->callback_target_destroy_notify = NULL;
#line 408 "../ssh/source.vala"
		_g_object_unref0 (_data13_->key);
#line 408 "../ssh/source.vala"
		_g_object_unref0 (self);
#line 408 "../ssh/source.vala"
		g_slice_free (Block13Data, _data13_);
#line 2931 "source.c"
	}
}

static gboolean
_seahorse_ssh_source_authorize_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_authorize_async_co (self);
#line 409 "../ssh/source.vala"
	return result;
#line 2942 "source.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 441 "../ssh/source.vala"
	return self ? g_error_copy (self) : NULL;
#line 2950 "source.c"
}

static void*
__lambda11_ (Block13Data* _data13_)
{
	SeahorseSshSource* self;
	GSourceFunc _tmp13_;
	gpointer _tmp13__target;
	GDestroyNotify _tmp13__target_destroy_notify;
	GError* _inner_error0_ = NULL;
	void* result = NULL;
#line 423 "../ssh/source.vala"
	self = _data13_->self;
#line 2964 "source.c"
	{
		SeahorseSshKeyData* keydata = NULL;
		SeahorseSshKeyData* _tmp0_;
		SeahorseSshKeyData* _tmp1_;
		SeahorseSshKeyData* _tmp2_;
		SeahorseSshKeyData* _tmp3_;
		const gchar* _tmp5_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		SeahorseSshKeyData* _tmp10_;
#line 425 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_key_get_key_data (_data13_->key);
#line 425 "../ssh/source.vala"
		_tmp1_ = _tmp0_;
#line 425 "../ssh/source.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 425 "../ssh/source.vala"
		keydata = _tmp2_;
#line 426 "../ssh/source.vala"
		_tmp3_ = keydata;
#line 426 "../ssh/source.vala"
		if (_tmp3_ == NULL) {
#line 2987 "source.c"
			GError* _tmp4_;
#line 427 "../ssh/source.vala"
			_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't authorize empty key.");
#line 427 "../ssh/source.vala"
			_inner_error0_ = _tmp4_;
#line 427 "../ssh/source.vala"
			_g_object_unref0 (keydata);
#line 2995 "source.c"
			goto __catch0_g_error;
		}
#line 430 "../ssh/source.vala"
		_tmp5_ = _data13_->from;
#line 430 "../ssh/source.vala"
		if (g_file_test (_tmp5_, G_FILE_TEST_EXISTS)) {
#line 3002 "source.c"
			const gchar* _tmp6_;
			SeahorseSshKeyData* _tmp7_;
#line 431 "../ssh/source.vala"
			_tmp6_ = _data13_->from;
#line 431 "../ssh/source.vala"
			_tmp7_ = keydata;
#line 431 "../ssh/source.vala"
			seahorse_ssh_key_data_filter_file (_tmp6_, NULL, _tmp7_, &_inner_error0_);
#line 431 "../ssh/source.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 431 "../ssh/source.vala"
				_g_object_unref0 (keydata);
#line 3015 "source.c"
				goto __catch0_g_error;
			}
		}
#line 435 "../ssh/source.vala"
		_tmp8_ = _data13_->to;
#line 435 "../ssh/source.vala"
		seahorse_ssh_source_ensure_file_exists (self, _tmp8_);
#line 436 "../ssh/source.vala"
		_tmp9_ = _data13_->to;
#line 436 "../ssh/source.vala"
		_tmp10_ = keydata;
#line 436 "../ssh/source.vala"
		seahorse_ssh_key_data_filter_file (_tmp9_, _tmp10_, NULL, &_inner_error0_);
#line 436 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 436 "../ssh/source.vala"
			_g_object_unref0 (keydata);
#line 3033 "source.c"
			goto __catch0_g_error;
		}
#line 439 "../ssh/source.vala"
		seahorse_ssh_key_refresh (_data13_->key);
#line 424 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 3040 "source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		GError* _tmp12_;
#line 424 "../ssh/source.vala"
		e = _inner_error0_;
#line 424 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 441 "../ssh/source.vala"
		_tmp11_ = e;
#line 441 "../ssh/source.vala"
		_tmp12_ = _g_error_copy0 (_tmp11_);
#line 441 "../ssh/source.vala"
		_g_error_free0 (_data13_->err);
#line 441 "../ssh/source.vala"
		_data13_->err = _tmp12_;
#line 424 "../ssh/source.vala"
		_g_error_free0 (e);
#line 3062 "source.c"
	}
	__finally0:
#line 424 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 424 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 424 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 424 "../ssh/source.vala"
		return NULL;
#line 3073 "source.c"
	}
#line 444 "../ssh/source.vala"
	_tmp13_ = _data13_->callback;
#line 444 "../ssh/source.vala"
	_tmp13__target = _data13_->callback_target;
#line 444 "../ssh/source.vala"
	_tmp13__target_destroy_notify = _data13_->callback_target_destroy_notify;
#line 444 "../ssh/source.vala"
	_data13_->callback = NULL;
#line 444 "../ssh/source.vala"
	_data13_->callback_target = NULL;
#line 444 "../ssh/source.vala"
	_data13_->callback_target_destroy_notify = NULL;
#line 444 "../ssh/source.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp13_, _tmp13__target, _tmp13__target_destroy_notify);
#line 445 "../ssh/source.vala"
	result = NULL;
#line 445 "../ssh/source.vala"
	return result;
#line 3093 "source.c"
}

static gpointer
___lambda11__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda11_ (self);
#line 423 "../ssh/source.vala"
	block13_data_unref (self);
#line 423 "../ssh/source.vala"
	return result;
#line 3105 "source.c"
}

static gboolean
seahorse_ssh_source_authorize_async_co (SeahorseSshSourceAuthorizeAsyncData* _data_)
{
#line 408 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 408 "../ssh/source.vala"
		case 0:
#line 3115 "source.c"
		goto _state_0;
#line 408 "../ssh/source.vala"
		case 1:
#line 3119 "source.c"
		goto _state_1;
		default:
#line 408 "../ssh/source.vala"
		g_assert_not_reached ();
#line 3124 "source.c"
	}
	_state_0:
#line 408 "../ssh/source.vala"
	_data_->_data13_ = g_slice_new0 (Block13Data);
#line 408 "../ssh/source.vala"
	_data_->_data13_->_ref_count_ = 1;
#line 408 "../ssh/source.vala"
	_data_->_data13_->self = g_object_ref (_data_->self);
#line 408 "../ssh/source.vala"
	_g_object_unref0 (_data_->_data13_->key);
#line 408 "../ssh/source.vala"
	_data_->_data13_->key = _data_->key;
#line 408 "../ssh/source.vala"
	_data_->_data13_->_async_data_ = _data_;
#line 409 "../ssh/source.vala"
	_data_->_data13_->callback = _seahorse_ssh_source_authorize_async_co_gsource_func;
#line 409 "../ssh/source.vala"
	_data_->_data13_->callback_target = _data_;
#line 409 "../ssh/source.vala"
	_data_->_data13_->callback_target_destroy_notify = NULL;
#line 410 "../ssh/source.vala"
	_data_->_data13_->err = NULL;
#line 415 "../ssh/source.vala"
	if (_data_->authorize) {
#line 416 "../ssh/source.vala"
		_data_->_tmp0_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 416 "../ssh/source.vala"
		_g_free0 (_data_->_data13_->from);
#line 416 "../ssh/source.vala"
		_data_->_data13_->from = _data_->_tmp0_;
#line 417 "../ssh/source.vala"
		_data_->_tmp1_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 417 "../ssh/source.vala"
		_g_free0 (_data_->_data13_->to);
#line 417 "../ssh/source.vala"
		_data_->_data13_->to = _data_->_tmp1_;
#line 3161 "source.c"
	} else {
#line 419 "../ssh/source.vala"
		_data_->_tmp2_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 419 "../ssh/source.vala"
		_g_free0 (_data_->_data13_->from);
#line 419 "../ssh/source.vala"
		_data_->_data13_->from = _data_->_tmp2_;
#line 420 "../ssh/source.vala"
		_data_->_tmp3_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 420 "../ssh/source.vala"
		_g_free0 (_data_->_data13_->to);
#line 420 "../ssh/source.vala"
		_data_->_data13_->to = _data_->_tmp3_;
#line 3175 "source.c"
	}
#line 423 "../ssh/source.vala"
	_data_->_tmp4_ = g_thread_new ("authorize-async", ___lambda11__gthread_func, block13_data_ref (_data_->_data13_));
#line 423 "../ssh/source.vala"
	_data_->thread = _data_->_tmp4_;
#line 448 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 448 "../ssh/source.vala"
	return FALSE;
#line 3185 "source.c"
	_state_1:
	;
#line 450 "../ssh/source.vala"
	_data_->_tmp5_ = _data_->thread;
#line 450 "../ssh/source.vala"
	_data_->thread = NULL;
#line 450 "../ssh/source.vala"
	g_thread_join (_data_->_tmp5_);
#line 452 "../ssh/source.vala"
	_data_->_tmp6_ = _data_->_data13_->err;
#line 452 "../ssh/source.vala"
	if (_data_->_tmp6_ != NULL) {
#line 453 "../ssh/source.vala"
		_data_->_tmp7_ = _data_->_data13_->err;
#line 453 "../ssh/source.vala"
		_data_->_tmp8_ = _g_error_copy0 (_data_->_tmp7_);
#line 453 "../ssh/source.vala"
		_data_->_inner_error0_ = _data_->_tmp8_;
#line 453 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 453 "../ssh/source.vala"
		_g_thread_unref0 (_data_->thread);
#line 453 "../ssh/source.vala"
		block13_data_unref (_data_->_data13_);
#line 453 "../ssh/source.vala"
		_data_->_data13_ = NULL;
#line 453 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 453 "../ssh/source.vala"
		return FALSE;
#line 3216 "source.c"
	}
#line 408 "../ssh/source.vala"
	_g_thread_unref0 (_data_->thread);
#line 408 "../ssh/source.vala"
	block13_data_unref (_data_->_data13_);
#line 408 "../ssh/source.vala"
	_data_->_data13_ = NULL;
#line 408 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 408 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 408 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 408 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3232 "source.c"
		}
	}
#line 408 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 408 "../ssh/source.vala"
	return FALSE;
#line 3239 "source.c"
}

static void
seahorse_ssh_source_ensure_file_exists (SeahorseSshSource* self,
                                        const gchar* filename)
{
	gint fd = 0;
#line 456 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 456 "../ssh/source.vala"
	g_return_if_fail (filename != NULL);
#line 457 "../ssh/source.vala"
	fd = open (filename, O_WRONLY | O_CREAT, (mode_t) 0644);
#line 458 "../ssh/source.vala"
	close (fd);
#line 3255 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_find_key_by_fingerprint (SeahorseSshSource* self,
                                             const gchar* fingerprint)
{
	SeahorseSshKey* result = NULL;
#line 461 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "../ssh/source.vala"
	g_return_val_if_fail (fingerprint != NULL, NULL);
#line 3267 "source.c"
	{
		guint i = 0U;
#line 462 "../ssh/source.vala"
		i = (guint) 0;
#line 3272 "source.c"
		{
			gboolean _tmp0_ = FALSE;
#line 462 "../ssh/source.vala"
			_tmp0_ = TRUE;
#line 462 "../ssh/source.vala"
			while (TRUE) {
#line 3279 "source.c"
				GListStore* _tmp2_;
				SeahorseSshKey* key = NULL;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				SeahorseSshKey* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 462 "../ssh/source.vala"
				if (!_tmp0_) {
#line 3289 "source.c"
					guint _tmp1_;
#line 462 "../ssh/source.vala"
					_tmp1_ = i;
#line 462 "../ssh/source.vala"
					i = _tmp1_ + 1;
#line 3295 "source.c"
				}
#line 462 "../ssh/source.vala"
				_tmp0_ = FALSE;
#line 462 "../ssh/source.vala"
				_tmp2_ = self->priv->keys;
#line 462 "../ssh/source.vala"
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp2_))) {
#line 462 "../ssh/source.vala"
					break;
#line 3305 "source.c"
				}
#line 463 "../ssh/source.vala"
				_tmp3_ = self->priv->keys;
#line 463 "../ssh/source.vala"
				_tmp4_ = g_list_model_get_item ((GListModel*) _tmp3_, i);
#line 463 "../ssh/source.vala"
				key = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, SEAHORSE_SSH_TYPE_KEY, SeahorseSshKey);
#line 464 "../ssh/source.vala"
				_tmp5_ = key;
#line 464 "../ssh/source.vala"
				_tmp6_ = seahorse_ssh_key_get_fingerprint (_tmp5_);
#line 464 "../ssh/source.vala"
				_tmp7_ = _tmp6_;
#line 464 "../ssh/source.vala"
				if (g_strcmp0 (_tmp7_, fingerprint) == 0) {
#line 465 "../ssh/source.vala"
					result = key;
#line 465 "../ssh/source.vala"
					return result;
#line 3325 "source.c"
				}
#line 462 "../ssh/source.vala"
				_g_object_unref0 (key);
#line 3329 "source.c"
			}
		}
	}
#line 469 "../ssh/source.vala"
	result = NULL;
#line 469 "../ssh/source.vala"
	return result;
#line 3337 "source.c"
}

SeahorseSshSource*
seahorse_ssh_source_construct (GType object_type)
{
	SeahorseSshSource * self = NULL;
#line 26 "../ssh/source.vala"
	self = (SeahorseSshSource*) g_object_new (object_type, NULL);
#line 26 "../ssh/source.vala"
	return self;
#line 3348 "source.c"
}

SeahorseSshSource*
seahorse_ssh_source_new (void)
{
#line 26 "../ssh/source.vala"
	return seahorse_ssh_source_construct (SEAHORSE_SSH_TYPE_SOURCE);
#line 3356 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_label (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	gchar* _tmp0_;
#line 46 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 46 "../ssh/source.vala"
	_tmp0_ = g_strdup (_ ("OpenSSH keys"));
#line 46 "../ssh/source.vala"
	result = _tmp0_;
#line 46 "../ssh/source.vala"
	return result;
#line 3373 "source.c"
}

static void
seahorse_ssh_source_real_set_label (SeahorsePlace* base,
                                    const gchar* value)
{
	SeahorseSshSource* self;
#line 47 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 47 "../ssh/source.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_LABEL_PROPERTY]);
#line 3385 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_description (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 51 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 51 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 51 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf (_ ("OpenSSH: %s"), _tmp0_);
#line 51 "../ssh/source.vala"
	result = _tmp1_;
#line 51 "../ssh/source.vala"
	return result;
#line 3405 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_uri (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 55 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 55 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 55 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf (_ ("openssh://%s"), _tmp0_);
#line 55 "../ssh/source.vala"
	result = _tmp1_;
#line 55 "../ssh/source.vala"
	return result;
#line 3425 "source.c"
}

static GIcon*
seahorse_ssh_source_real_get_icon (SeahorsePlace* base)
{
	GIcon* result;
	SeahorseSshSource* self;
	GThemedIcon* _tmp0_;
#line 59 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 59 "../ssh/source.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (GCR_ICON_HOME_DIRECTORY);
#line 59 "../ssh/source.vala"
	result = (GIcon*) _tmp0_;
#line 59 "../ssh/source.vala"
	return result;
#line 3442 "source.c"
}

static SeahorsePlaceCategory
seahorse_ssh_source_real_get_category (SeahorsePlace* base)
{
	SeahorsePlaceCategory result;
	SeahorseSshSource* self;
#line 63 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 63 "../ssh/source.vala"
	result = SEAHORSE_PLACE_CATEGORY_KEYS;
#line 63 "../ssh/source.vala"
	return result;
#line 3456 "source.c"
}

static GActionGroup*
seahorse_ssh_source_real_get_actions (SeahorsePlace* base)
{
	GActionGroup* result;
	SeahorseSshSource* self;
#line 67 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 67 "../ssh/source.vala"
	result = NULL;
#line 67 "../ssh/source.vala"
	return result;
#line 3470 "source.c"
}

static const gchar*
seahorse_ssh_source_real_get_action_prefix (SeahorsePlace* base)
{
	const gchar* result;
	SeahorseSshSource* self;
#line 71 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 71 "../ssh/source.vala"
	result = NULL;
#line 71 "../ssh/source.vala"
	return result;
#line 3484 "source.c"
}

static GMenuModel*
seahorse_ssh_source_real_get_menu_model (SeahorsePlace* base)
{
	GMenuModel* result;
	SeahorseSshSource* self;
#line 75 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 75 "../ssh/source.vala"
	result = NULL;
#line 75 "../ssh/source.vala"
	return result;
#line 3498 "source.c"
}

static gboolean
seahorse_ssh_source_real_get_show_if_empty (SeahorsePlace* base)
{
	gboolean result;
	SeahorseSshSource* self;
#line 79 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 79 "../ssh/source.vala"
	result = TRUE;
#line 79 "../ssh/source.vala"
	return result;
#line 3512 "source.c"
}

const gchar*
seahorse_ssh_source_get_base_directory (SeahorseSshSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 86 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 86 "../ssh/source.vala"
	result = _tmp0_;
#line 86 "../ssh/source.vala"
	return result;
#line 3528 "source.c"
}

static GObject *
seahorse_ssh_source_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseSshSource * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 89 "../ssh/source.vala"
	parent_class = G_OBJECT_CLASS (seahorse_ssh_source_parent_class);
#line 89 "../ssh/source.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 89 "../ssh/source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 90 "../ssh/source.vala"
	_tmp0_ = g_get_home_dir ();
#line 90 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf ("%s/.ssh", _tmp0_);
#line 90 "../ssh/source.vala"
	_g_free0 (self->priv->ssh_homedir);
#line 90 "../ssh/source.vala"
	self->priv->ssh_homedir = _tmp1_;
#line 93 "../ssh/source.vala"
	_tmp2_ = self->priv->ssh_homedir;
#line 93 "../ssh/source.vala"
	if (!g_file_test (_tmp2_, G_FILE_TEST_EXISTS)) {
#line 3560 "source.c"
		const gchar* _tmp3_;
#line 94 "../ssh/source.vala"
		_tmp3_ = self->priv->ssh_homedir;
#line 94 "../ssh/source.vala"
		if (g_mkdir (_tmp3_, 0700) != 0) {
#line 3566 "source.c"
			const gchar* _tmp4_;
#line 95 "../ssh/source.vala"
			_tmp4_ = self->priv->ssh_homedir;
#line 95 "../ssh/source.vala"
			g_warning ("source.vala:95: couldn't create .ssh directory: %s", _tmp4_);
#line 96 "../ssh/source.vala"
			return obj;
#line 3574 "source.c"
		}
	}
#line 100 "../ssh/source.vala"
	seahorse_ssh_source_monitor_ssh_homedir (self);
#line 89 "../ssh/source.vala"
	return obj;
#line 3581 "source.c"
}

static void
seahorse_ssh_source_class_init (SeahorseSshSourceClass * klass,
                                gpointer klass_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_parent_class = g_type_class_peek_parent (klass);
#line 26 "../ssh/source.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshSource_private_offset);
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_source_get_property;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_source_set_property;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_ssh_source_constructor;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_source_finalize;
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_LABEL_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_URI_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ICON_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", SEAHORSE_PLACE_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY] = g_param_spec_string ("action-prefix", "action-prefix", "action-prefix", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY] = g_param_spec_boolean ("show-if-empty", "show-if-empty", "show-if-empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3618 "source.c"
	/**
	     * The directory containing the SSH keys.
	     */
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY] = g_param_spec_string ("base-directory", "base-directory", "base-directory", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3624 "source.c"
}

static void
seahorse_ssh_source_gcr_collection_interface_init (GcrCollectionIface * iface,
                                                   gpointer iface_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_gcr_collection_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../ssh/source.vala"
	iface->get_length = (guint (*) (GcrCollection*)) seahorse_ssh_source_real_get_length;
#line 26 "../ssh/source.vala"
	iface->get_objects = (GList* (*) (GcrCollection*)) seahorse_ssh_source_real_get_objects;
#line 26 "../ssh/source.vala"
	iface->contains = (gboolean (*) (GcrCollection*, GObject*)) seahorse_ssh_source_real_contains;
#line 3639 "source.c"
}

static void
seahorse_ssh_source_seahorse_place_interface_init (SeahorsePlaceIface * iface,
                                                   gpointer iface_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_seahorse_place_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../ssh/source.vala"
	iface->load = (void (*) (SeahorsePlace*, GCancellable*, GAsyncReadyCallback, gpointer)) seahorse_ssh_source_real_load;
#line 26 "../ssh/source.vala"
	iface->load_finish = (gboolean (*) (SeahorsePlace*, GAsyncResult*, GError**)) seahorse_ssh_source_load_finish;
#line 26 "../ssh/source.vala"
	iface->get_label = seahorse_ssh_source_real_get_label;
#line 26 "../ssh/source.vala"
	iface->set_label = seahorse_ssh_source_real_set_label;
#line 26 "../ssh/source.vala"
	iface->get_description = seahorse_ssh_source_real_get_description;
#line 26 "../ssh/source.vala"
	iface->get_uri = seahorse_ssh_source_real_get_uri;
#line 26 "../ssh/source.vala"
	iface->get_icon = seahorse_ssh_source_real_get_icon;
#line 26 "../ssh/source.vala"
	iface->get_category = seahorse_ssh_source_real_get_category;
#line 26 "../ssh/source.vala"
	iface->get_actions = seahorse_ssh_source_real_get_actions;
#line 26 "../ssh/source.vala"
	iface->get_action_prefix = seahorse_ssh_source_real_get_action_prefix;
#line 26 "../ssh/source.vala"
	iface->get_menu_model = seahorse_ssh_source_real_get_menu_model;
#line 26 "../ssh/source.vala"
	iface->get_show_if_empty = seahorse_ssh_source_real_get_show_if_empty;
#line 3672 "source.c"
}

static void
seahorse_ssh_source_instance_init (SeahorseSshSource * self,
                                   gpointer klass)
{
	GListStore* _tmp0_;
#line 26 "../ssh/source.vala"
	self->priv = seahorse_ssh_source_get_instance_private (self);
#line 38 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = (guint) 0;
#line 40 "../ssh/source.vala"
	self->priv->monitor_handle = NULL;
#line 43 "../ssh/source.vala"
	_tmp0_ = g_list_store_new (SEAHORSE_SSH_TYPE_KEY);
#line 43 "../ssh/source.vala"
	self->priv->keys = _tmp0_;
#line 3690 "source.c"
}

static void
seahorse_ssh_source_finalize (GObject * obj)
{
	SeahorseSshSource * self;
#line 26 "../ssh/source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 36 "../ssh/source.vala"
	_g_free0 (self->priv->ssh_homedir);
#line 40 "../ssh/source.vala"
	_g_object_unref0 (self->priv->monitor_handle);
#line 43 "../ssh/source.vala"
	_g_object_unref0 (self->priv->keys);
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (seahorse_ssh_source_parent_class)->finalize (obj);
#line 3707 "source.c"
}

/**
 * The {@link Place} where SSH keys are stored. By default that is ~/.ssh.
 * Basically, this becomes an interface to the SSH home directory.
 */
 G_GNUC_NO_INLINE static GType
seahorse_ssh_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshSource), 0, (GInstanceInitFunc) seahorse_ssh_source_instance_init, NULL };
	static const GInterfaceInfo gcr_collection_info = { (GInterfaceInitFunc) seahorse_ssh_source_gcr_collection_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_place_info = { (GInterfaceInitFunc) seahorse_ssh_source_seahorse_place_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_ssh_source_type_id;
	seahorse_ssh_source_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshSource", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_ssh_source_type_id, gcr_collection_get_type (), &gcr_collection_info);
	g_type_add_interface_static (seahorse_ssh_source_type_id, SEAHORSE_TYPE_PLACE, &seahorse_place_info);
	SeahorseSshSource_private_offset = g_type_add_instance_private (seahorse_ssh_source_type_id, sizeof (SeahorseSshSourcePrivate));
	return seahorse_ssh_source_type_id;
}

GType
seahorse_ssh_source_get_type (void)
{
	static volatile gsize seahorse_ssh_source_type_id__volatile = 0;
	if (g_once_init_enter (&seahorse_ssh_source_type_id__volatile)) {
		GType seahorse_ssh_source_type_id;
		seahorse_ssh_source_type_id = seahorse_ssh_source_get_type_once ();
		g_once_init_leave (&seahorse_ssh_source_type_id__volatile, seahorse_ssh_source_type_id);
	}
	return seahorse_ssh_source_type_id__volatile;
}

static void
_vala_seahorse_ssh_source_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SeahorseSshSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 26 "../ssh/source.vala"
	switch (property_id) {
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_LABEL_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_label ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_description ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_URI_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_uri ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ICON_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_icon ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_enum (value, seahorse_place_get_category ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_actions ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_string (value, seahorse_place_get_action_prefix ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_menu_model ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_SHOW_IF_EMPTY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_boolean (value, seahorse_place_get_show_if_empty ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_string (value, seahorse_ssh_source_get_base_directory (self));
#line 26 "../ssh/source.vala"
		break;
#line 3810 "source.c"
		default:
#line 26 "../ssh/source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../ssh/source.vala"
		break;
#line 3816 "source.c"
	}
}

static void
_vala_seahorse_ssh_source_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SeahorseSshSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 26 "../ssh/source.vala"
	switch (property_id) {
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_LABEL_PROPERTY:
#line 26 "../ssh/source.vala"
		seahorse_place_set_label ((SeahorsePlace*) self, g_value_get_string (value));
#line 26 "../ssh/source.vala"
		break;
#line 3836 "source.c"
		default:
#line 26 "../ssh/source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../ssh/source.vala"
		break;
#line 3842 "source.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

